/*
 ķ
   Program..: DCSTD.CH                              
   Author...: Roger J. Donnay                       
   Notice...: (c) DONNAY Software Designs 1987-2001 
   Date.....: Oct  7, 2001                          
   Notes....: eXPress++ 2.0 command translations    
 Ľ
*/

/*
#define TAGGED  dc_tagged()
#define tagged  dc_tagged()
#define Tagged  dc_tagged()
*/

#include "std.ch"
#include "appevent.ch"
#include "inkey.ch"
#include "dmlb.ch"
#include "dbfdbe.ch"
#include "set.ch"
#include "memvar.ch"
#include "dccustom.ch"
#include "dcdialog.ch"
#include "dcprint.ch"

#command  ?  [<list,...>]  =>  DC_DotQOUT( {<list>} )
#command  ?? [<list,...>]  =>  DC_DotQQOUT( {<list>} )

#command . => DC_DOTSTACK()

#command / <cmd> => DC_TURBEDIT("'+ <cmd> + '")


* -- A -- *

#Command ABROWSE <array> [<sym:SYMMETRICAL>]                                  ;
                 [<asym:NONSYMMETRICAL,ASYMMETRICAL>]                         ;
         => <array> := DC_CrtRun({||DC_ABrowse(<array>,[<.sym.>][!<.asym.>])},;
                       'Browsing Array: ' + <(array)>)

#Command AVIEW <array> [<ex:EXPAND>} => DC_ArrayView( <array>, <.ex.> )

#Command AEDIT <array> => <array> := DC_CrtRun({||DC_AEDIT(<array>)},         ;
                       'Editing Array: ' + <(array)>)

#Command AEVAL <a>,<c> [DO] <b> [START <x>] [COUNT <y>]                       ;
         => ;
         AEVAL(<a>,{|<c>|<b>},<x>,<y>)

#Command AEVAL <a> [DO] <b,...> [START <x>] [COUNT <y>]                       ;
         => ;
         AEVAL(<a>,{|<a>|<b>},<x>,<y>)

#command APPEND SHARED FROM <c> => DC_CrtRun({||DC_AppShared(<(c)>)})

#Command APPEND VIRTUAL                                                        ;
         => ;
         IF DC_ADDREC(); DC_VirtRepl(DC_VirtRest()); DC_UNLOCK(); ENDIF

#command APPEND IMPORT                                                         ;
         => ;
         IF !EMPTY(ALIAS()) .AND. DC_ADDREC();                                 ;
         DC_IMPREPLACE(DC_IMPMAPREAD()); DC_UNLOCK(); ENDIF

#Command APPEND BLANK => IF DC_ADDREC(); DC_UNLOCK(); ENDIF

#command APPEND [FROM <(file)>]                                                ;
         [FIELDS <fields,...>] [FOR <for>] [WHILE <while>]                     ;
         [NEXT <next>] [RECORD <rec>] [<rest:REST>] [ALL]                      ;
         DELIMITED [WITH <*delim*>]                                            ;
         [<lNoProgress:NOPROGRESS>]   ;
         => ;
         DC_APPDELIM(<(file)>,<(delim)>,{<(fields)>},                          ;
         <{for}>,<{while}>,<next>,<rec>,<.rest.>,'Appended',[!<.lNoProgress.>])

#command APPEND [FROM <(file)>] [SDF] [FIELDS <fields,...>]                    ;
         [FOR <for>] [WHILE <while>] [NEXT <next>]                             ;
         [RECORD <rec>] [<rest:REST>] [ALL]                                    ;
         [<lNoProgress:NOPROGRESS>]   ;
         => ;
         DC_APPSDF(<(file)>,{<(fields)>},                                      ;
         <{for}>,<{while}>,<next>,<rec>,<.rest.>,'Appended',[!<.lNoProgress.>])

#command APPEND [FROM <(file)>] [FIELDS <fields,...>]                          ;
         [FOR <for>] [WHILE <while>] [NEXT <next>]                             ;
         [RECORD <rec>] [<rest:REST>] [VIA <(rdd)>] [ALL]                      ;
         [<lNoProgress:NOPROGRESS>]   ;
         => ;
         DC_DbImport(<(file)>,[{<(fields)>}],                  ;
         <{for}>,<{while}>,<next>,<rec>,<.rest.>,<(rdd)>,,,,'Appended',,[!<.lNoProgress.>])

#Command APPEND => DC_CrtRun({||DC_EDITDB(,,,,,,,.t.)})

#Command AVERAGE [ <x1> [, <xn>]  TO  <v1> [, <vn>] ] [FOR <for>]             ;
         [WHILE <while>] [NEXT <next>] [RECO <rec>] [<rest:REST>] [ALL]       ;
         => ;
         M->__Avg := <v1> := [ <vn> := ] 0                                    ;
         ; DC_dbeval({|| M->__Avg := M->__Avg + 1,                               ;
         <v1> := <v1> + <x1> [, <vn> := <vn> + <xn>] },                       ;
         <{for}>, <{while}>,  ;
         <next>,<rec>,<.rest.>,,.t., 'Averaging Records','Averaged') ;
         ;<v1> := <v1> / M->__Avg [; <vn> := <vn> / M->__Avg ]

#Command AVERAGE <x1> TO  <v1> [, <xn> TO <vn>] [FOR <for>]                   ;
         [WHILE <while>] [NEXT <next>] [RECO <rec>] [<rest:REST>] [ALL]       ;
         => ;
         M->__Avg := <v1> := [ <vn> := ] 0 ;                                  ;
         DC_dbeval({|| M->__Avg := M->__Avg + 1,                                 ;
         <v1> := <v1> + <x1> [, <vn> := <vn> + <xn>] },                       ;
         <{for}>, <{while}>,<next>,<rec>,<.rest.>,,.t.,'Averaging Records','Averaged') ;
         ;<v1> := <v1> / M->__Avg [; <vn> := <vn> / M->__Avg ]

#Command AVERAGE => DC_Average()

* -- B -- *

#Command BATCH <file> [<c1> [<c2> [<c3> [<c4> [<c5>]]]]]  ;
         => ;
         DC_Batch(<(file)>,<c1>,<c2>,<c3>,<c4>,<c5>)

#Command BATCH NEW <file> [<c1> [<c2> [<c3> [<c4> [<c5>]]]]]  ;
         => ;
         DC_BatchNewThread(<(file)>,<c1>,<c2>,<c3>,<c4>,<c5>)

#Command BATCH <file> PARAMS <c1> [<c2> [<c3> [<c4> [<c5>]]]]  ;
         => ;
         DC_Batch(<(file)>,<c1>,<c2>,<c3>,<c4>,<c5>)

#Command BATCH NEW <file> PARAMS <c1> [<c2> [<c3> [<c4> [<c5>]]]]  ;
         => ;
         DC_BatchNewThread(<(file)>,<c1>,<c2>,<c3>,<c4>,<c5>)

#command BEGIN [SEQUENCE] => BEGIN

#command BEGIN TRANSACTION => dbCommitAll() ; AX_Transaction(1)

#Command BLANK [FOR <for>] [WHILE <while>] [NEXT <next>]                        ;
         [RECORD <rec>] [<rest:REST>] [ALL]                                     ;
         => ;
         DC_dbeval({||DC_BLANK()},                                                 ;
         <{for}>,<{while}>,<next>,<rec>,<.rest.>,,.t.,'Blanking Records','Blanked')

#Command BLANK [RECORD] => DC_BLANK()

#command BROWSE GUI RESTORE [FROM <f>] => DC_BrowGuiRestore(<f>)

#command BROWSE DELETE [<c>] => DC_BrowDel(<c>)

#command BROWSE TILE [ WINDOW <mode>] [<e: EDIT>]                              ;
         [<onetomany: ONETOMANY>] [<cascade: CASCADE>] [<list,...>]            ;
         => ;
         DC_BROWTILE(<mode>,{<(list)>},,<.onetomany.>,<.e.>,<.cascade.>)

#command BROWSE SCAN [<field>] => DC_BROWSCAN(<(field)>)

#command BROWSE RELATION [WINDOW <mode>] [<alias1> INTO <into1>[ON <field1>]]  ;
         [, <aliasn> INTO <inton> [ON <fieldn>]] [<k:KEEPCURRENT>]             ;
         => ;
         DC_BROWRELA(<mode>,{{<(alias1)>,<(into1)>,<(field1)>}                 ;
         [,{<(aliasn)>,<(inton)>,<(fieldn)>}]},<.k.>)

#command BROWSE RESTORE [FROM] <f> [<p:PROTECT>] [<n:NOONE2MANY>] [<k:PICK>]   ;
         => ;
         DC_BrowRest(<(f)>,,,<.k.>,,<.n.>,<.p.>)

#command BROWSE RESTORE => DC_BrowRest()

#command BROWSE IMPORT [<f>] => DC_BROWIMP(<(f)>)

#command BROWSE [<p:PROTECT>] [FIELDS <l,...>] [HEADERS <h,...>]               ;
         [<e:EDIT>] [<d:DEFAULT>] [RESTORE [FROM] <f>]                         ;
         [MENU <m>] [KEYS <k>] [<c:CLEAR>] [<a:ALL>] [<o:OVERLAY>]             ;
         => ;
         IIF(<.c.>,DC_BROWCLEAR(IIF(<.a.>,0,nil)),nil);                        ;
         DC_BrowseDb(,[{{<(l)>},{<h>}}],,,,,                                   ;
         <(f)>,<.e.>,<.p.>,<(m)>,<(k)>,,!<.o.>,<.d.>)

#command BROWSE => DC_Dbu('/BROW','/NOSTAT')

#command BROWSE TEXT => DC_BrowseDb()


* -- C -- *

#Command CALC => _lGui := DC_Gui(.t.) ; DC_PopCalc() ; DC_Gui(_lGui)

#command CANCEL => DC_Quit()

#command CASE <b1,...> DO <c1,...>  [; <bn,...> DO <cn,...>]                 ;
         => ;
         DC_DOCASE( { {||<b1>} [,{||<bn>}] }, { {||<c1>} [,{||<cn>}] } )

#command CASE <exp> => CASE <exp>

#Command CD.. => DC_ChDir('..')

#Command CD .. => DC_ChDir('..')

#Command CD <(dir)> => IF !DC_ChDir(<(dir)>) ; DCMSGBOX 'Invalid Directory' TIMEOUT 1 ; ENDIF

#command CLEAR ALL => DC_WinAlert("CLEAR ALL not supported")

#command CLEAR MEMORY => DC_WinAlert("CLEAR MEMORY not supported")

#Command CLEAR SCOPE => DC_ClrScope(0) ; DC_ClrScope(1)

#Command CHDIR <dir> => CD <dir>

#Command CHR => ? DC_CrtRun({||DC_CHRSEL()})

#Command CLS => _oDotWindow := DC_DotWindow() ; IF !Empty(_oDotWindow) ; _oDotWindow:setData('') ; ENDIF

#Command CODE EDIT [TABLE] [<g>] => DC_CODEEDIT(<(g)>)

#Command CODE DELETE [TABLE] [<g>] => DC_CODEDELETE(<(g)>)

#Command CODE IMPORT [TABLE] [<g>] => DC_CODEIMPORT(<(g)>)

#Command CODE RENAME [<g>] TO [<h>] => DC_CODERENAME(<(g)>,<(h)>)

#command COLOR SETUP => DC_CLRSETUP(.T.)

#command COLOR => __Dummy := DC_CLRSEL() ; @ 24,0 SAY "" ; ? __Dummy

#Command COMPILE <file> [ OPTIONS <options> ] [<q:QUIET>] [<w:NOWINDOW>]    ;
         [<r:RECOMPILE>]                                                    ;
         =>                          ;                                      ;
         DC_Compile( <(file)>, <(options)>, <.q.>, !<.w.>, <.r.> )

#command COMMIT TRANSACTION => dbCommitAll() ; AX_Transaction(2)

#command CONF => DC_CONFIGDISP()

#command CONTINUE => _cont_ := DC_WaitOn();DC_dbContinue();DC_Impl(_cont_)

#xcommand COPYDOS <a> [<b>] [<p>...] => DC_DotQOUT() ; DC_GATEWAY("COPY <a> <b> <p>") ; DC_DotQOUT()

#xCommand COPYNEW <*from*> TO <*to*> => DC_CopyNew(<(from)>,<(to)>)

#xCommand COPYNEW => DC_CopyNew()

#Command COPY TO <(file)> SDF [FIELDS <fields,...>]                                          ;
         [FOR <for>] [WHILE <while>] [NEXT <next>]                                           ;
         [RECORD <rec>] [<rest:REST>] [VIA <(rdd)>] [ALL] [EVERY <every>] [<x:EXIT>] ;
         [<lNoProgress:NOPROGRESS>]   ;
         => ;
         DC_dbExport(<(file)>,{<(fields)>},                                                    ;
         <{for}>,<{while}>,<next>,<rec>,<.rest.>,"SDFDBE",,<every>,,,<.x.>,[!<.lNoProgress.>])

#Command COPY TO <(file)> DELIMITED [WITH <*delim*>] [FIELDS <fields,...>]                   ;
         [FOR <for>] [WHILE <while>] [NEXT <next>]                                           ;
         [RECORD <rec>] [<rest:REST>] [VIA <(rdd)>] [ALL] [<x:EXIT>]          ;
         [<lNoProgress:NOPROGRESS>]   ;
         => ;
         DC_dbExport(<(file)>,{<(fields)>},                                                    ;
         <{for}>,<{while}> ;
         <next>,<rec>,<.rest.>,"DELDBE",<(delim)>,,,,,<.x.>,[!<.lNoProgress.>])

#Command COPY TO <(file)> [FIELDS <fields,...>]                                              ;
          [FOR <for>] [WHILE <while>] [NEXT <next>]                                          ;
          [RECORD <rec>] [<rest:REST>] [VIA <(rdd)>] [ALL] [EVERY <every>] [<x:EXIT>]                  ;
          [<lNoProgress:NOPROGRESS>]   ;
          => ;
          DC_dbExport(<(file)>,{<(fields)>},                                                   ;
          <{for}>,<{while}>,<next>,<rec>,<.rest.>,<(rdd)>,,<every>,,,<.x.>,[!<.lNoProgress.>])

#Command COUNT [TO <var>] [FOR <for>] [WHILE <while>] [NEXT <next>]           ;
         [RECORD <rec>] [<rest:REST>] [ALL] [EVERY <every>] ;
         => ;
         M->__Cnt := [<var> :=] 0              ;
         ; DC_DbEval({||M->__Cnt := M->__Cnt+1 [,<var> := <var>+1]},             ;
         <{for}>, <{while}>,<next>,<rec>,<.rest.>,,.t.,'Counting Records','Counted',<every>) ;
         ; ? <var>

#Command COUNT => DC_Count()

#Command CREATE <file> => DC_Create(<(file)>)

#Command CRT <block> [TITLE <title>] [COLOR <color> =>  ;
         DC_CrtRun( <block>, <title>, <color> )


* -- D -- *

#Command DATE => _lGui := DC_Gui(.t.) ; DC_PopDate() ; DC_Gui(_lGui)

#Command DATACONVERT [<(filename)>]  [FROMDBE <(fromdbe)>]                 ;
         [TODBE <(todbe)> [EXTENSION <*ext*>]                              ;
         => DC_DataConvert(<(filename)>,<(fromdbe)>,<(todbe)>,<(ext)>)

#Command DBU [<list,...>] => DC_Dbu( <(list)> )

#Command DELETE [FOR <for>] [WHILE <while>] [NEXT <next>]                                    ;
         [RECORD <rec>] [<rest:REST>] [ALL] [EVERY <every>]                                  ;
         => ;
         IF !DC_SETT("AUTOLOCK") .OR. DC_FILOCK();                                           ;
         DC_dbeval({||dbDelete()},<{for}>,<{while}>,                                         ;
         <next>,<rec>,<.rest.>,,.t.,'Deleting Records','Deleted',<every>) ; UNLOCK; ENDIF

#Command DELETE FILE <(file)> => DC_DotQout(IIF(FErase(<(file)>)=0,"","File not found..."))

#Command DELETE FILE => DC_Erase()

#Command DELETE                                                                              ;
         => ;
         IF !DC_SETT("AUTOLOCK") .OR. DC_RECLOCK();                                          ;
         dbDelete() ; ENDIF ; IF DC_SETT("AUTOLOCK") ; UNLOCK ; ENDIF

#Command DELETE TAG => DC_TAGDELETE()

#command DIALOG [OPTIONS <aOptions>] [CONFIG <(cConfig)>] => ;
         DC_Dialog( <aOptions>, <(cConfig)> )

#command DICTIONARY EDIT => DC_DICTEDIT()

#command DICTIONARY RESTORE [<area>] => DC_DICTREST(<area>)

#command DICTIONARY SAVE [<area>] => DC_DICTSAVE(<area>)

#command DICTIONARY TRANSLATE <field> => DC_DotQOUT(DC_DICTTRAN(<(field)>))

#Command DIR [<*wildcard*>] => DC_Dir(<(wildcard)>)

#Command DISPLAY  [<off:OFF>] [<toPrint: TO PRINT>]                                ;
         [TO FILE <(toFile)>] [FOR <for>] [WHILE <while>] [NEXT <next>]            ;
         [RECORD <rec>] [<rest:REST>] [<all:ALL>] [<list,...>]                     ;
         => ;
         DC_LIST(<.off.>, { <{list}> }, <.all.>,<{for}>,<{while}>,                 ;
         <next>, <rec>, <.rest.>,<.toPrint.>, <(toFile)>)

#Command DISPLAY STATUS => DC_Status()

#Command DISPLAY STRUCTURE WIDE  => DC_DbStruW(4,0,22,79)

#Command DISPLAY STRUCTURE => DC_DbStru()

#command DISPLAY MEMORY FILE [ALL] TO [FILE] <file2>                         ;
         => ;
         DC_MemOutAll(<(file2)>)

#Command DISPLAY MEMORY [FILE <file1>] [TO [FILE] <file2>]  ;
         [<a:APPEND>] [<n:NAMESONLY>]  ;
         => ;
         DC_DispMem(<(file1)>,<(file2)>,<.a.>,<.n.>)

#command DISPLAY ARRAY <array> [TO [FILE] <file>]                            ;
         => ;
         DC_CrtRun({||_DCDISPARRAY(<(array)>,<array>,[<(file)>])})

#command DISPLAY OBJECT <array> [TO [FILE] <file>]                           ;
         => ;
         _DCDISPARRAY(<(array)>,<array>,[<(file)>])

#command DLLFUNC <func> [IN <dll>] [CONVENTION <n>] [[PARAMS] <list,...>]      ;
         => ;
         DC_DLLCALL<(dll)>,<n>,<(func)>,<list>)

#Command DLL [LOAD] <dll> => DC_DllLoad(<(dll)>)

#Command DLL UNLOAD [<dll>] => DC_DllUnload(<(dll)>)

#Command DLL LIST => DC_DllList()

#command DO <proc> [WITH <list,...>]  => [_DCDOTDO('<proc>(<list>)',.f.)]

#command DO WHILE <exp>  => DOWHILE <exp>

#command DO CASE => DOCASE

#command DOS => DC_GateWay()

#command DUMP <file> [TO [FILE] <outfile>] [<p:PREVIEW>] [<a:ACROBAT>] ;
         => DC_DUMP(<(file)>,.f.,<(outfile)>,<.p.>,<.a.>)


* -- E -- *

#command EDIT FILE <file> [LINE <line>]
         => ;
         DC_EditPrg(<(file)>,<line>)

#command EDIT MEMO [<memo>] => DC_EDMEMO([<(memo)>])

#command EDIT PRG <file> [LINE <line>]
         => ;
         DC_EditPrg(<(file)>,<line>)

#command EDIT PRG                                                              ;
         => ;
         DC_EDITPRG("'+DC_OBJFIND(DC_PROCNAME())+'.PRG",STR(DC_LINENO()),,.t.)

#command EDIT TILE [WINDOW <mode>] [<rel:RELATION>] [<list,...>]               ;
         => ;
         DC_EDITTILE(<mode>,{<(list)>},,<.rel.>)

#Command EDIT VIRTUAL                                                          ;
         => ;
         IF !EMPTY(ALIAS())                                                    ;
           ;DC_CrtRun({||DC_VirtSave(DC_VirtEdit(DC_VirtRest()))})             ;
         ;ENDIF

#command EDIT [<p:PROTECT>] [FIELDS <l,...>] [HEADERS <h,...>]                 ;
         [MENU <m>] [KEYS <k>] [<c:CLEAR>] [<a:ALL>]                           ;
         [<o:OVERLAY>] [PAGE <n>]                                              ;
         => ;
         IIF(<.c.>,DC_EDITCLEAR(IIF(<.a.>,0,nil)),nil) ;                       ;
         DC_EDITDB({,,,,,,,,,,,,,,,<n>},[{{<(l)>},{<h>}}],,,,,,,,,<.p.>,       ;
         <(m)>,<(k)>,,!<.o.>)

#command EDIT RESTORE [FROM] <f> [PAGE <n>] [<p:PROTECT>]                      ;
         => ;
         DC_EditRest(<(f)>,,,,<n>,<.p.>)

#command EDIT RESTORE => DC_EditRest()

#command EDIT DELETE [<f>] => DC_EDITDEL(<(f)>)

#command EDIT IMPORT [<f>] => DC_EDITIMP(<(f)>)

#command EDIT => DC_Dbu('/EDIT','/NOSTAT')

#command EDIT TEXT => DC_EditDb()

#command ELSEIF <exp> => ELSEIF <exp>

#command END => END

#command ENDIF => ENDIF

#command ENDCASE => ENDCASE

#command ENDDO => ENDDO

#command ERASE <(file)> => DC_DotQout(IIF(FErase(<(file)>)=0,"","File not found..."))

#command EJECT => IF DC_PRTEST() ; _Eject() ; ENDIF

#command EVENT CLEAR => DC_ClearEvents()

#command EVENT [LOOP] => DC_AppEvent()


* -- F -- *

#command FIELD EDIT [GROUP] [<g>] => DC_FIELDEDIT(<(g)>)

#command FIELD IMPORT [GROUP] [<g>] => DC_FIELDIMP(<(g)>)

#command FIELD DELETE [GROUP] [<g>] => DC_FIELDDELETE(<(g)>)

#Command FILE EDIT [GROUP <g>] => DC_FileEdit(<(g)>)

#Command FILE RESTORE [GROUP <g>] [<add:ADDITIVE>] [<ex:EXCLUSIVE>] ;
              [TAG <(tag)>] ;
         => DC_FileRest(<(g)>,<.add.>,<.ex.>,<(tag)>)

#Command FILE SAVE [GROUP <g>] [FROM <a>] [<w:WORKAREAS>] ;
         => DC_FileSave(<a>,,<.w.>,<(g)>)

#Command FILE IMPORT [GROUP <g>] => DC_FileImp(<(g)>)

#Command FILE DELETE [GROUP <g>] => DC_FileDel(<(g)>)

#Command FIND => dc_find()

#command FOR <x> := <a> TO <b> [STEP <c>] => FORNEXT <x> <a> <b> <c>

#command FOR <x> = <a> TO <b> [STEP <c>] => FOR <x> := <a> TO <b> [STEP <c>]

#command FOR <x>,<a> TO <b> [STEP <c>] DO <list,...> [WHILE <w,...>]         ;
         => ;
         DC_FORNEXT(<a>,<b>,<c>,{|<x>|<list>} [,{|<x>|<w>}])

#command FMAP EDIT [<map>] => DC_FMapEdit(<(map)>)

#command FMAP DELETE [<map>] => DC_FMapDelete(<(map)>)

#command FMAP IMPORT [<map>] => DC_FMapPort(<(map)>)


* -- G -- *

#command GATEWAY => DC_CrtRun({||DC_GATEMEN("","'+cUpperParam+'")})

#command GBROWSE => DC_GuiGrumpBrow('AEDCQOISVLF',0,0,17,90,,,,,,,,,,,,,,,,,,,,,DC_DbfName())

#Command GO TOP => DC_dbGoTop()

#Command GO BOTTOM => DC_dbGoBottom()

#Command GOTO TOP => DC_dbGoTop()

#Command GOTO BOTTOM => DC_dbGoBottom()

#Command GUI <x:ON,OFF,&>          =>  DC_Gui( <(x)> )
#Command GUI (<x>)                 =>  DC_Gui( <x> )


* -- H -- *

#command HELP [<*cmd*>] => DC_DotHelp(#<cmd>)

#Command HUNT => DC_HUNT()

#Command HUNT <*arg*> => DC_HUNT(#<arg>)


* -- I -- *

#command IF <exp> => IF <exp>

#command IF <exp> GOLINE <label> => IF <exp>; DC_BATGOLINE(<(label)>); ENDIF

#Command IF <b> DO <x> [ ELSE <y> ] => DC_IFELSE({||<b>},{||<x>} [,{||<y>}])

#command IMPORT FROM <alias> [MAP <map>]                                                ;
         [FOR <for>] [WHILE <while>] [NEXT <next>] [RECORD <rec>] [<rest:REST>] [ALL]   ;
         => ;
         IIF(EMPTY(ALIAS()),DC_DotQOUT("'+DC_TR2MSG_1+'"),                                    ;
         DC_IMPORT(<(alias)>,<(map)>,<{for}>,<{while}>,<next>,<rec>,<.rest.>))

#command IMPORT LOAD [<file>] => DC_IMPMAPSTORE(DC_IMPMAPLOAD(<(file)>))

#command IMPORT CREATE <file> [FROM <importfile> TO <targetfile>]                       ;
         => ;
         DC_IMPMAPCREATE(<(file)>,<(targetfile)>,<(importfile)>)

#Command INDEX FIELDS [<list,...>] [LENGTH <nLength>] [TO <(file)>]                          ;
         => ;
         DC_TAGALLCREATE(<(file)>,{<(list)>},<nLength>)

#Command INDEX ON <key> [TAG <(cTag)>] [TO <(cFile)>]                                        ;
         [FOR <for>] [<all:ALL>] [WHILE <while>] [NEXT <next>]                               ;
         [RECORD <rec>] [<rest:REST>] [EVAL <eval>] [EVERY <every>]                          ;
         [<un: UNIQUE>] [<asc: ASCENDING>] [<desc: DESCENDING>]                              ;
         [<uc: USECURRENT>] [<add: ADDITIVE>] [<noodd:NOODOMETER>] [<cus: CUSTOM>]           ;
         => ;
         DC_CondSet(<(for)>,<{for}>,[<.all.>],<{while}>,<{eval}>, <every>,                   ;
         RECNO(),<next>,<rec>,[<.rest.>],[<.desc.>],<(cFile)>,,                     ;
         <.uc.>,<.cus.>,,,!<.noodd.>) ;                                                      ;
         DC_OrdCreate(<(cFile)>,<(cTag)>,<(key)>,<{key}>,[<.un.>],[<.add.>])

#Command INDEX ON <key> TAG <(tag)> [OF <(cdx)>] [FOR <for>] [<all:ALL>]                     ;
         [WHILE <while>] [NEXT <next>] [RECORD <rec>] [<rest:REST>]      ;
         [<asc:ASCENDING>] [<dec:DESCENDING>] [<u:UNIQUE>] [<empty:EMPTY>] ;
         [<cur:USECURRENT>] [<cur:SUBINDEX>] [EVAL <opt> [EVERY <step>]] ;
         [OPTION <opt> [STEP <step>]] [<add:ADDITIVE>] [<shad:SHADOW>]  ;
         [<filt:FILTERON>] [<cus:CUSTOM>] ;
         => ;
         DC_CondSet(<"for">, <{for}>,if( <.all.>, .t., NIL ),<{while}>, ;
         <{opt}>, <step>, RECNO(), <next>, <rec>,if( <.rest.>, .t., NIL ), ;
         iif( (<.dec.> .AND. !<.asc.>), .t., NIL ), ;
         .t., <(cdx)>, <.cur.>, <.empty.>.OR.<.cus.>, .f., <.add.>, ;
         <.shad.>, <.filt.>) ; DC_OrdCreate(<(cdx)>, <(tag)>, <"key">, <{key}>, [<.u.>])

#Command INKEY => DC_InkeyDsp()

#Command INSERT [<virt: VIRTUAL>] [<recs>] => DC_INSERT(<recs>,<.virt.>)

#Command INTERPRET [CLIPBOARD] [MEMVAR <c>] [FILE <f>] [WITH <list,...>]     ;
         => ;
         DC_Interpret( [<c>] [MemoRead(<(f)>)], {<list>} )


* -- J -- *

#command JOIN => DC_Join()

* -- K -- *

#command KEY LOAD [GROUP] [<g>] => DC_KEYLOAD(<(g)>)

#command KEY EDIT [GROUP] [<g>] => DC_KEYEDIT(<(g)>)

#command KEY DELETE [GROUP] [<g>] => DC_KEYDELETE(<(g)>)

#command KEY CLEAR [ALL] [GROUP] [<g>] => DC_KEYCLEAR(<(g)>)

#command KEY FILE <f> [ALIAS <a>] => DC_KEYFILE(<(f)>,<(a)>)

#command KEY IMPORT [GROUP] [<g>] => DC_KEYIMPORT(<(g)>)

#command KEY HELP => DC_KEYHELP()

#command KEY DISPLAY => DC_KEYDISP(7)

* -- L -- *

#command LABEL FORM <lbl> [<sample: SAMPLE>] [<noconsole: NOCONSOLE>]                         ;
         [<print: TO PRINT>] [TO FILE <(toFile)>] [FOR <for>]                                 ;
         [WHILE <while>] [NEXT <next>] [RECORD <rec>] [<rest:REST>] [ALL]                     ;
         => ;                                                                                 ;
         DC_LBLFORM(<(lbl)>,<.print.>,<(toFile)>,<.noconsole.>,                               ;
         <{for}>,<{while}>,<next>,<rec>,<.rest.>,<.sample.>)

#command LABEL FORM => DC_LBLOUT()

#command LABEL => DC_REPORT()

#Command LIST STATUS => DC_STATUS()

#Command LIST STRUCTURE => DC_DBSTRU()

/*
#Command LIST [ALL] [<off:OFF>] [<toPrint: TO PRINTER>]                                      ;
         [TO FILE <(toFile)>] [FOR <for>] [WHILE <while>]                                    ;
         [NEXT <next>] [RECORD <rec>] [<rest:REST>] [<list,...>]                             ;
         => ;
         DC_LIST(<.off.>,{<{list}>},.t.,<{for}>,<{while}>,                                   ;
         <next>,<rec>,<.rest.>,<.toPrint.>,<(toFile)>)
*/

#Command LOCATE [FOR <for>] [WHILE <while>] [NEXT <next>] [RECORD <rec>] [<rest:REST>] [ALL] ;
         => ;
         DC_dbLocate( <{for}>,DC_ODBLOCK(<{while}>,<{for}>,<next>,,,.t.,,,<.rest.>),            ;
         <next>, <rec>, <.rest.> ); dc_odactive(.f.)

#Command LOCK FILE => DC_Filock()

#Command LOCK ALL => DC_Filock()

#Command LOCK EDIT => DC_LockMaint()

#Command LOCK => DC_RECLOCK()

#Command LOG [TO <file>] => DC_Log(DC_ProcName(3),DC_LineNo(3),,<(file)>)

#Command LOGIN [USER <userid>] [PASSWORD <password>]                          ;
         => ;
         DC_UserLogin(<(userid)>,<(password)>)

* -- M -- *

#command MAP ADD <file> SOURCE <source> PROCEDURE <list,...>                            ;
         => ;
         DC_MAPADD(<(file)>,<(source)>,<(list)>)

#command MAP OBJ <mapfile> [LIST <listfile>] [<wildcard>]                               ;
         => ;
         DC_MAPCREATE(<(mapfile)>,<(wildcard)>,<(listfile)>,.t.)

#command MAP UNLOAD <map> => DC_MAPUNLD(<(map)>)

#command MAP EDIT [<map>] => DC_MAPEDIT(<(map)>)

#command MAP DELETE [<map>] => DC_MAPDELETE(<(map)>)

#command MAP CREATE <mapfile> [LIST <listfile>] [<wildcard>]                            ;
         => ;
         DC_MAPCREATE(<(mapfile)>,<(wildcard)>,<(listfile)>,.f.)

#command MAP PRG <mapfile> [LIST <listfile>] [<wildcard>]                               ;
         => ;
         DC_MAPCREATE(<(mapfile)>,<(wildcard)>,<(listfile)>,.f.)

#command MAP [LOAD] <file> => DC_MAPLOAD(<(file)>)

#command MAP => DC_MAPLIST()

#command MEMO IMPORT <memo> [FROM <file>] [<repl:REPLACE>] [<ins:INSERT>]      ;
         => ;
         DC_MEMOIN(<(memo)>,<(file)>,iif(<.repl.>,"R",iif(<.ins.>,"I","A")))

#command MEMO EXPORT <memo> [TO <file>] [<repl:REPLACE>] [<ins:INSERT>]        ;
         => ;
         DC_MEMOOUT(<(memo)>,<(file)>,'iif(<.repl.>,"R",iif(<.ins.>,"I","A")))

#command MEMO COPY [FILE <a>] [TO <b>] [FROM <c>]                              ;
         [REFERENCE <d>] [RECORD <n>] [MODE <e>]                               ;
         [INSERT <f>] [APPEND <g>]                                             ;
         => ;
         DC_MEMOCOPY(<(b)>,<(c)>,<(d)>,<(a)>,<n>,<(e)>,<(f)>,<(g)>)

#command MENU [RUN] [<m>] => DC_MenuRun(<(m)>)

#Command MENU EDIT [<m>] [<c:CREATE>] => DC_MenuEdit(<(m)>,<.c.>)

#Command MENU CREATE [<m>] => DC_MenuEdit(<(m)>,.t.)

#command MENU IMPORT [<m>] => DC_MenuImp(<(m)>)

#command MENU DELETE [<m>] => DC_MenuDel(<(m)>)

#command MODIFY REPORT [<(file)>] => DC_FRMMODIFY(<(file)>)

#command MODIFY XREPORT [<(file)>] => DC_FRMMODIFY(<(file)>,.T.)

#command MODIFY LABEL [<(file)>] => DC_LBLMODIFY(<(file)>)

#Command MODIFY STRUCTURE [TO <file>] => DC_MODSTRU(<(file)>)

#command MODIFY COMMAND <(file)> [<(param)>] => DC_MODCOMM(<(file)>,<(param)>)

* -- N -- *

#command NEXT => NEXT


* -- O -- *

#command OBJ RELEASE <obj> => DC_OBJRELE(<(obj)>,.t.)

#Command OBJ [LOAD] <obj> [RUN <proc>]                                ;
         => ;
         DC_OBJLOAD(<(obj)>,<proc>)


* -- P -- *

#Command PACK => dc_pack(.t.)

#command PRINTER [MAINTENANCE] => DC_PRINT()

#command PRINTER SELECT => DC_PRINTSEL()

#command PRINTER CODE => DC_PRINTCODE()

#command PRINTER <code> => DC_SETP(<(code)>,.t.,.f.,.t.,.f.)

#command PRG FORMAT [<cPrgFile>] [INDENT <nIndent>] => DC_PrgFormat(<cPrgFile>,<nIndent>)

#command PROCEDURE CLEAR [<num>] => DC_PROC(,<num>,.t.)

#command PROCEDURE <proc> => DC_PROC(<(proc)>)

#command PROCEDURE => DC_PROC()

#Command PROGRAM [<prog>] [WITH <list,...>] => DC_Program(<(prog)>,{<list>})

#Command PROGRAM MAINTENANCE [<prog>] => DC_ProgMaint(<(prog)>)

#command PURGE [ON <expr>] [TO <file>] [RETAIN <ret>] [<max:MAX>] [<min:MIN>]                ;
         [FIELD <fld>] [<uc:CURINDEX>] [<cr:CURREC>]'                                        ;
         => ;
         DC_PURGE(<(expr)>,<(file)>,<(ret)>,<.max.>.AND.!<.min.>,<(fld)>,<.uc.>,<.cr.>)


* -- Q -- *

#command QUERY [TO] <memv> => <memv> := DC_QUERY()

#command QUIT => DC_Quit()


* -- R -- *

#Command RECALL [FOR <for>] [WHILE <while>] [NEXT <next>]                                    ;
         [RECORD <rec>] [<rest:REST>] [ALL]                                                  ;
         => ;
         IF !DC_SETT("AUTOLOCK") .OR. DC_FILOCK();                                           ;
         DC_dbeval({||dbRecall()},<{for}>,<{while}>,<next>,             ;
         <rec>,<.rest.>,,.t.,'Recalling Records','Recalled') ; UNLOCK ; ENDIF

#Command RECALL                                                                              ;
         => IF !DC_SETT("AUTOLOCK") .OR. DC_RECLOCK();                                       ;
         dbRecall(); ENDIF; IF DC_SETT("AUTOLOCK"); UNLOCK; ENDIF

#command REINDEX [EVAL <eval> [EVERY <every>]] ;
         => ;
         IF DC_ISSHARED() ; DC_DotQout("Exclusive Required") ; ELSE ; ;
         IIF(DC_SUPERRDD()="DBFNTX",DC_DotQOUT("Reindexing, Please wait.."),  ;
         DC_CONDSET(,,,, <{eval}>, <every>,,,,,,,)) ; ;
         DC_REINFLAG(.t.) ; OrdListRebuild() ; DC_REINFLAG(.f.) ; DC_ODACTIVE(.f.) ; ENDIF

#command REINDEX  ;
         => ;
         IF DC_ISSHARED() ; DC_DotQout("Exclusive Required") ; ELSE ; dbReindex() ; ENDIF

#Command REPLACE [WITH] VIRTUAL => DC_VirtRepl(DC_VirtRest())

#command REPLACE [WITH] IMPORT => DC_IMPREPLACE(DC_IMPMAPREAD())

#command REPLACE ARRAY [FIELD] <f> ELEMENT <n> WITH <x> => DC_ArrayField(<(f)>,<n>,<x>)

#Command REPLACE [ALL] [<f1> WITH <x1> [,<fn> WITH <xn>]] [FOR <for>]                        ;
         [WHILE <while>] [NEXT <next>] [RECORD <rec>] [<rest:REST>] [ALL]                    ;
         => ;
         DC_dbeval({||DC_RECLOCK(5), FIELD-><f1> := <x1> [, FIELD-><fn> := <xn>], dbRUnlock()},<{for}>,      ;
         <{while}>,<next>,<rec>,<.rest.>,,.t.,'Replacing Records','Replaced'); UNLOCK

#Command REPLACE <f1> WITH <v1> [, <fN> WITH <vN>                                            ;
         => ;
         IF !DC_SETT("AUTOLOCK") .OR. DC_RECLOCK();                                          ;
         FIELD-><f1> := <v1> [; FIELD-><fN> := <vN>] ;                                       ;
         UNLOCK; ENDIF

#Command REPLACE => DC_Replace()

#command REDO <proc> [WITH <list,...>]                                       ;
         => ;
         DC_OBJRELE(DC_OBJFIND(<(proc)>),.T.) ; _DCDOTDO('<proc>(<list>)',.f.)

#command REPORT FORM <frm> [HEADING <heading>] [<plain: PLAIN>]                               ;
         [<noeject: NOEJECT>] [<summary: SUMMARY>] [<noconsole: NOCONSOLE>]                   ;
         [<print: TO PRINT>] [TO FILE <(toFile)>] [FOR <for>]                                 ;
         [WHILE <while>] [NEXT <next>] [RECORD <rec>] [<rest:REST>] [ALL]                     ;
         => ;
         DC_FRMREPORT(<(frm)>,<.print.>,<(toFile)>,<.noconsole.>,                             ;
         <{for}>,<{while}>,<next>,<rec>,<.rest.>,<.plain.>,<heading>,                         ;
         <.noeject.>,<.summary.> )

#Command RESTORE ARRAY <array> FROM <(file)> => <array> := DC_ARestore(<(file)>)

#Command RESTORE ARRAY <array> => <array> := DC_ARestore(<(array)> + '.DCA')

#Command RESTORE DATA FROM <array> => DC_DataRest(<array>)

#command RESTORE WORK [FROM <file>] [<a:ADDITIVE>] [<e:EXCLUSIVE>]              ;
         [<n:NONADDITIVE>] [<q:QUIET>] [<v:VERBOSE>]                            ;
         => ;
         DC_FILEREST(<(file)>,<.a.>.OR.!<.n.>,!<.q.>.AND.<.v.>,,<.e.>)

#Command RESTORE SET FROM <file> => DC_SetRest(<(file)>)

#command RESTORE => IF Type('_d_c_sscrn') = 'C' ; 'RESTSCREEN(_d_c_sscrn,0,0,MAXROW(),79) ; ENDIF

#command RESTORE TAGS [FROM <file>] => DC_TAGRESTORE(<(file)>,.t.)

#command RESUME => DC_HUNT(,.t.)

#command RETURN <exp> => RETURN <exp>

#command ROLLBACK TRANSACTION => dbCommitAll() ; AX_Transaction(3)


* -- S -- *

#Command SEARCH <f> [FOR <v>] [<print: TO PRINT>] [TO FILE <(dest)>]                            ;
         => ;
         DC_Search(<(f)>,<(v)>,iif(<.print.>,"PRN",<(dest)>))

#Command SEARCH => DC_Search()

#command SCREEN PAINT [GROUP] [<g>] ;
         => _dc_scrn := DC_SCRNLOAD(<(g)>) ; DC_SCRNPAINT(_dc_scrn)

#command SCREEN EDIT [GROUP] [<g>] => DC_SCRNEDIT(<(g)>)

#command SCREEN DELETE [GROUP] [<g>] => DC_SCRNDELETE(<(g)>)

#command SCREEN IMPORT [GROUP] [<g>] => DC_SCRNIMPORT(<(g)>)

#command SCREEN FILE <f> [ALIAS <a>] => DC_SCRNFILE(<(f)>,<(a)>)

#Command SAVE SET TO <file> => DC_SetSave(<(file)>)

#command SAVE TAGS [TO <file>] => DC_TAGSAVE(<(file)>,,.t.)

#Command SAVE ARRAY <array> TO <file> => DC_ASave(<array>,<(file)>)

#Command SAVE ARRAY <array> => DC_ASave(<array>,<(array)>+".DCA")

#command SAVE WORK [TO <file>] [AS <desc>] [<q: QUIET>] ;
         => ;
         DC_WORKSAVE(<(file)>,<desc>,!<.q.>)

#Command SAVE DATA TO <array> => <array> := DC_DataSave()

#Command SAVE VIRTUAL => DC_VirtSave(DC_VirtCapt())

#Command SEEK <x> => DC_dbSeek(<x>)

#Command SEEK => DC_Find()

#Command SELECT => dc_dbfsel()

#command SELECT INDEX <key> => DC_INDEXSEL(<(key)>)

#Command SET => DC_SetEdit()

#command SET SUPERRDD TO <(rdd)> => DC_SUPERRDD(<(rdd)>)

#Command SET DBE [TO <cDbe>] => DC_RddSel(<(cDbe)>,.t.)
#Command SET RDD [TO <cRdd>] => DC_RddSel(<(cRdd)>,.t.)

#command SET DBEDICT [TO <cDbe>] => DC_DictRdd(<(cDbe)>)
#command SET RDDDICT [TO <cRdd>] => DC_DictRdd(<(cRdd)>)

#command SET TAG TO <(tag)> [OF <(cdx)>] [IN <(cdx)>] ;
         => DC_TagSet(<(tag)>,<(cdx)>)
#command SET TAG TO => DC_TagSet()
#command SET TAG => DC_TagSel()
#command SET TAGORDER TO [<(tag)>] => DC_TagSet(<(tag)>)

#command SET ORDER => DC_DBISEL()

#Command SET COMMAND TO <verb>, <command>             ;
         => DC_COMMADD(<(verb)>,<(command)>)

#Command SET AUTOLOCK <x:ON,OFF,&>     =>  DC_Sett("AUTOLOCK", <(x)> )
#Command SET AUTOLOCK (<x>)            =>  DC_Sett("AUTOLOCK", <x> )

#command SET AUTOPEN ON => DC_SETT("AUTOPEN",.t.)
#command SET AUTOPEN OFF => DC_SETT("AUTOPEN",.f.)
#command SET AUTOINDEX ON => DC_SETT("AUTOINDEX",.t.)
#command SET AUTOINDEX OFF => DC_SETT("AUTOINDEX",.f.)
#command SET AUTORDER TO <x> => DC_SETT("AUTORDER",<x>)
#command SET AUTOSHARE TO <x> => DC_SETT("AUTOSHARE",<x>)

#Command SET PROCEDURE TO <verb>, <command> => DC_COMMADD(<(verb)>,<(command)>,0,"","P")

#Command SET BATCH TO <verb>, <command> => DC_COMMADD(<(verb)>,<(command)>,0,"","B")

#command SET FUNCTION <n> [TO] [<c>] => __SetFunction( <n>, <c> )

#command SET FILTER [<op:OPTIMIZE>] TO <xpr> => DC_SetFilter(#<xpr>,<.op.>)

#command SET INDEX TO ? => DC_SETINDEX()
#command SET INDEX [<add: ADDITIVE>] [TO [ <(list,...)>]] ;
         => ;
         if !<.add.> ; ordListClear() ; endif [; DC_SETINDEX({<(list)>})]

#Command SET SCOPE TO <value> => DC_SETSCOPE(0,<value>) ; DC_SETSCOPE(1,<value>)
#Command SET SCOPE TO <value1>, <value2> => DC_SETSCOPE(0,<value1>);DC_SETSCOPE(1,<value2>)
#Command SET SCOPE TO => DC_CLRSCOPE()
#Command SET SCOPE TOP TO => DC_SETSCOPE(0,nil)
#Command SET SCOPE TOP TO <value> => DC_SETSCOPE(0,<value>)
#Command SET SCOPE BOTTOM TO => DC_SETSCOPE(1,nil)
#Command SET SCOPE BOTTOM TO <value> => DC_SETSCOPE(1,<value>)

#Command SET PDIR TO [<(value)>]    => DC_SETT("PDIR",<(value)>)
#Command SET ODIR TO [<(value)>]    => DC_SETT("ODIR",<(value)>)
#Command SET PROMPT TO [<*value*>]  => DC_SETT("PROMP",<(value)>)
#command SET DCLIP TO [<(value)>]   => DC_SETT("DCLIP",<(value)>)
#command SET EXPRESS TO [<(value)>] => DC_SETT("DCLIP",<(value)>)
#Command SET XPPPATH TO [<(value)>] => DC_SETT("XPP",<(value)>)
#Command SET XPPOPT TO [<(value)>]  => DC_SETT("XPPOPT",<(value)>)
#command SET PEXT TO [<(value)>]    => DC_SETT("PEXT",<(value)>)
#command SET DEFAULT TO <(value)>   => DC_SETT("DEFAULT",<(value)>)
#command SET PATH TO <(value)>      => DC_SETT("PATH",<(value)>)
#Command SET DBE TO [<(value)>]     => DC_SETT("RDD",<(value)>)
#Command SET RDD TO [<(value)>]     => DC_SETT("RDD",<(value)>)
#Command SET EDITOR TO [<(value)>]  => DC_SETT("EDITOR",<(value)>)
#command SET TURBO TO [<*value*>]   => DC_SETT("TURBO",<(value)>)

#Command SET RELATION                                                 ;
         [TO <key1> INTO <(alias1)> [<scoped1:SCOPED>]                ;
         [, TO <keyN> INTO <(aliasN)> [<scopedN:SCOPED>]]             ;
         [<add:ADDITIVE>]                                             ;
         =>                                                           ;
         IF (!<.add.>);dbClearRel(); ENDIF ;                          ;
         DC_SetRelation(<(alias1)>,<{key1}>,<"key1">,<.scoped1.>)     ;
         [;DC_SetRelation(<(aliasN)>,<{keyN}>,<"keyN">,<.scopedN.>)  ]

#Command SET GUI <x:ON,OFF,&>      =>  DC_Gui( <(x)> )
#Command SET GUI (<x>)             =>  DC_Gui( <x> )

#command SET HELP <x:ON,OFF,&>     =>  DC_Sett("HELP", <(x)> )
#command SET HELP (<x>)            =>  DC_Sett("HELP", <x> )

#command SET EXPLODE <x:ON,OFF,&>  =>  DC_Sett("EXPL", <(x)> )
#command SET EXPLODE (<x>)         =>  DC_Sett("EXPL", <x> )

#command SET KEYS <x:ON,OFF,&>     =>  DC_Sett("KEYS", <(x)> )
#command SET KEYS (<x>)            =>  DC_Sett("KEYS", <x> )

#Command SET TALK <x:ON,OFF,&>     =>  DC_Sett("TALK", <(x)> )
#Command SET TALK (<x>)            =>  DC_Sett("TALK", <x> )

#command SET ECHO <x:ON,OFF,&>     =>  DC_Sett("ECHO", <(x)> )
#command SET ECHO (<x>)            =>  DC_Sett("ECHO", <x> )

#command SET DEBUG <x:ON,OFF,&>    =>  DC_Sett("DEBUG", <(x)> )
#command SET DEBUG (<x>)           =>  DC_Sett("DEBUG", <x> )

#command SET SOUND <x:ON,OFF,&>    =>  DC_Sett("SOUND", <(x)> )
#command SET SOUND (<x>)           =>  DC_Sett("SOUND", <x> )

#command SET THUMB <x:ON,OFF,&>    =>  DC_Sett("THUMB", <(x)> )
#command SET THUMB (<x>)           =>  DC_Sett("THUMB", <x> )

#command SET DOSKEY <x:ON,OFF,&>   =>  DC_Sett("DOSKEY", <(x)> )
#command SET DOSKEY (<x>)          =>  DC_Sett("DOSKEY", <x> )

#Command SET STATUS <x:ON,OFF,&>   =>  DC_Sett("STATUS", <(x)> )
#Command SET STATUS (<x>)          =>  DC_Sett("STATUS", <x> )

#command SET STICKY <x:ON,OFF,&>   =>  DC_Sett("STICKY", <(x)> )
#command SET STICKY (<x>)          =>  DC_Sett("STICKY", <x> )

#command SET CUA <x:ON,OFF,&>      =>  DC_Sett("CUA", <(x)> )
#command SET CUA (<x>)             =>  DC_Sett("CUA", <x> )

#command SET PUBLIC <x:ON,OFF,&>   =>  DC_Sett("PUBLIC", <(x)> )
#command SET PUBLIC (<x>)          =>  DC_Sett("PUBLIC", <x> )

#command SET FIELDBLOCKDEBUG <x:ON,OFF,&>    =>  DC_FieldWDebug( <(x)> )
#command SET FIELDBLOCKDEBUG (<x>)           =>  DC_FieldWDebug( <x> )

#command SET MAXROWS TO <x> =>  DC_Sett("MAXR", <x> )
#command SET FLDKEY TO <x> =>  DC_Sett("FLDK", <x> )
#command SET CHRKEY TO <x> =>  DC_Sett("CHRK", <x> )
#command SET QUERYKEY TO <x> =>  DC_Sett("QUER", <x> )
#command SET FLUSH TO <x> =>  DC_Sett("FLUS", <x> )
#command SET ODOMETER TO <x> =>  DC_Sett("ODOM", <x> )
#command SET DOTSTACK TO <x> =>  DC_Sett("DOTS", <x> )
#command SET MFILE TO <x> =>  DC_Sett("MFIL", <x> )
#command SET MEMORY TO <x> =>  DC_Sett("MEMO", <x> )
#command SET MBLOCK TO <x> =>  DC_Sett("MBLO", <x> )
#command SET EVENT TO <x> =>  DC_Sett("EVEN", <x> )
#command SET VIDEO TO <x> =>  DC_Sett("VIDE", <x> )

#Command SKIP ALIAS <a> => <a> -> (DC_dbSkip(1))

#Command SKIP <n> ALIAS <a> => <a> -> (DC_dbSkip(<n>))

#Command SKIP <n> => DC_dbSkip(<n>)

#Command SKIP => DC_dbSkip(1)

#command SORT => DC_SORT()

#command SORT [TO <(file)>] [ON <fields,...>] [FOR <for>]                                    ;
         [WHILE <while>] [NEXT <next>] [RECORD <rec>] [<rest:REST>] [ALL]                    ;
         => ;
         dbSort(<(file)>,{<(fields)>},                                                       ;
         <{for}>, DC_ODBLOCK(<{while}>,<{for}>,<next>,,"Sorted",,.t.,,<.rest.>),             ;
         <next>,<rec>,<.rest.>); dc_odactive(.f.)

#xtranslate SQLSELECT <*x*> => DC_AdsRunSQL( "SELECT " + <(x)> )

#command SQL CONNECT [<c>] [TO <conn>] => [<conn> := ] DC_SQLConnection( <(c)> )

#command SQLexpress CONNECT [<c>] [TO <conn>] => [<conn> := ] DC_SQLConnection( <(c)> )

#command SQL STATEMENT <cStatement> [CONNECTION <oConn>] [TYPE <nType>] [TO <oCursor>] ;
         [PARAM <bSQLParam>] [PRIMARYKEYS <aPrimaryKeys>] [MAXROWS <nMaxRows>] ;
         [ADDCOL <abAddCol>] [FILTER <bFilter>] [<lTrim:TRIM>] [<lDateTimeAsDate:DATETIMEASDATE>] ;
         [TABLENAME <(cTableName)>] ;
         => ;
         [<oCursor> := ] DC_SQLCursor( <oConn>, <nType>,, <cStatement>, <bSQLParam>, ;
                                      <aPrimaryKeys>, <nMaxRows>, <abAddCol>, <bFilter>, ;
                                      <.lTrim.>, <.lDateTimeAsDate.>, <cTableName> )

#command SQL SELECT [STATEMENT] <cStatement> [CONNECTION <oConn>] [TO <oCursor>] ;
         [PARAM <bSQLParam>] [PRIMARYKEYS <aPrimaryKeys>] [MAXROWS <nMaxRows>] ;
         [ADDCOL <abAddCol>] [FILTER <bFilter>] [<lTrim:TRIM>] [<lDateTimeAsDate:DATETIMEASDATE>] ;
         => ;
         [<oCursor> := ] DC_SQLCursor( <oConn>, 0,, <cStatement>, <bSQLParam>, ;
                                      <aPrimaryKeys>, <nMaxRows>, <abAddCol>, <bFilter>, ;
                                      <.lTrim.>, <.lDateTimeAsDate.> )

#command SQL DATASET [STATEMENT] <cStatement> [CONNECTION <oConn>] [TO <oCursor>] ;
         [PARAM <bSQLParam>] [PRIMARYKEYS <aPrimaryKeys>] [MAXROWS <nMaxRows>] ;
         [ADDCOL <abAddCol>] [FILTER <bFilter>] [<lTrim:TRIM>] [<lDateTimeAsDate:DATETIMEASDATE>] ;
         => ;
         [<oCursor> := ] DC_SQLCursor( <oConn>, 2,, <cStatement>, <bSQLParam>, ;
                                      <aPrimaryKeys>, <nMaxRows>, <abAddCol>, <bFilter>, ;
                                      <.lTrim.>, <.lDateTimeAsDate.> )

#command SQL ADS [QUERY] [TO <x>] => ;
    Eval({|o|o:=Thread():new():start({||DC_AdsSQLQuery(,,,DC_Path(AppName(.t.))+'..\data\',[<(x)>])})})

#command ADS SQL [QUERY] [TO <x>] => ;
    Eval({|o|o:=Thread():new():start({||DC_AdsSQLQuery(,,,DC_Path(AppName(.t.))+'..\data\',[<(x)>])})})

#Command STACK => DC_CallStack()

#command SYNTAX <cmd> => IF !DC_SYNTAX(<cmd>)) ; DC_Help(<cmd>,.f.,,.t.) ; ENDIF

#Command SUM <x1> [, <xn>]  TO  <f1> [, <fn>]   [FOR <for>]                   ;
         [WHILE <while>] [NEXT <next>] [RECORD <rec>] [<rest:REST>] [ALL]     ;
         => ;
         <f1> := [ <fn> := ] 0;                                               ;
         DC_dbeval({|| <f1> := <f1> + <x1> [, <fn> := <fn> + <xn>] },            ;
         <{for}>, <{while}>,<next>,<rec>,<.rest.>,,.t.,'Summing Records','Summed')

#Command SUM <x1> TO  <f1> [, <xn> TO <fn>]   [FOR <for>]                     ;
         [WHILE <while>] [NEXT <next>] [RECORD <rec>] [<rest:REST>] [ALL]'    ;
         => ;
         <f1> := [ <fn> := ] 0;                                               ;
         DC_dbeval({|| <f1> := <f1> + <x1> [, <fn> := <fn> + <xn>] },            ;
         <{for}>,<{while}>,<next>,<rec>,<.rest.>,,.t.,'Summing Records','Summed')

#Command SUM => DC_Sum()


* -- T -- *

#Command TAG CLEAR ALL => DC_RECTAGCLEAR()

#Command TAG [TO <a>] => DC_RECTAG(,<a>)

#command TAG DELETE => DC_TAGDELETE()

#Command TAG CLEAR [TO <a>] => DC_RECTAG(.t.,<a>)

#Command TAG [TO <a>] [<c:CLEAR>] [FOR <for>] [WHILE <while>] [NEXT <n>]       ;
         [ALL] [<rest:REST>] [RECORD <rec>]                                    ;
         => ;
         [<a> :=] DC_RECTAG(<.c.>,<a>,<{for}>,<{while}>,<n>,<rec>,<.rest.>)

#command TAG BROWSE [TO <a>] [FIELDS <list,...>]                               ;
         => ;
         [<a> :=] DC_RECTAGBROWSE({<(list)>},                                  ;
         iif(type("<a>")="A",<a>,nil))

#command TOTAL [TO <(file)>] [ON <key>] [FIELD <fields,...>]                                  ;
         [FOR <for>] [WHILE <while>] [NEXT <next>] [RECORD <rec>] [<rest:REST>] [ALL]         ;
         => ;
         dbTotal(<(file)>,<{key}>,{<(fields)>},                                               ;
         <{for}>, DC_ODBLOCK(<{while}>,<{for}>,<next>,,"Totalled",,.t.,,<.rest.>),            ;
         <next>,<rec>,<.rest.>); dc_odactive(.f.)

#command TUTOR [<command>] => DC_TUTOR(<(command)>)

#command TYPE <(file)> [<print: TO PRINT>] [TO FILE <(dest)>]                                ;
         => ;
         DC_TypeFile(<(file)>,<.print.>) ; [_dcCopyFile(<(file)>,<(dest)>)]

* -- U -- *

#Command UNLOCK => dbUnlock()

#command UPDATE [FROM <(alias)>] [ON <key>]                                             ;
         [REPLACE <f1> WITH <x1> [, <fn> WITH <xn>]] [<rand:RANDOM>]                    ;
         => ;
         IF !DC_SETT("AUTOLOCK") .OR. DC_FILOCK();                                      ;
         dbUpdate(<(alias)>,<{key}>,<.rand.>,                                           ;
         {||FIELD-><f1> := <x1> [,FIELD-><fn> := <xn>]}) ; UNLOCK; ENDIF

#Command USER EDIT [<userID>] => DC_UserMaint(<(userID)>)

#Command USER LOGIN [ID <userID>] [PASSWORD <pass>] ;
         => DC_UserLogIn(<(userID)>,<(pass)>)

#command USE ALL [LIKE <wildcard>] [VIA <(rdd)>] [<ex: EXCLUSIVE>]                       ;
         [<sh: SHARED>] [<ro: READONLY>]                                                 ;
         => ;
         dc_useall(<(wildcard)>,<(rdd)>, if(<.sh.> .or. <.ex.>,!<.ex.>,NIL),<.ro.>)

#command USE ? => dc_use()

#Command USE <(db)> [<fox: FOX>] [VIA <(rdd)>] [ALIAS <a>] [<new: NEW>]                  ;
         [<ex: EXCLUSIVE>] [<sh: SHARED>] [<ro: READONLY>]                               ;
         [INDEX <list,...>] [<ai: AUTOINDEX>] [PASSWORD <(pass)>] [ALTERNATE <(altrdd)>] ;
         [FROM <dict>] => ;
         DC_USEAREA(<.new.>, IIF(<.fox.>,"FOXRDD",<(rdd)>),                              ;
         <(db)>,<(a)>,IIF(<.sh.> .or. <.ex.>,                                            ;
         !<.ex.>,NIL),<.ro.>,.t.,,,,<.ai.>,<(altrdd)>,<(dict)>)                          ;
         [; DC_SetIndex({<(list)>})]       ;
         [; DC_SetPass(<(pass)>)]

#Command DUSE <(db)> [ALIAS <a>] [<new: NEW>] ;
         [<ex: EXCLUSIVE>] [<sh: SHARED>] [<ro: READONLY>]                               ;
         =>                                                                              ;
         DC_USEAREA(<.new.>, nil,<(db)>,<(a)>,IIF(<.sh.>.or.<.ex.>,!<.ex.>,NIL),         ;
                    <.ro.>,.t.,,,,,,'.ADD')


#command USE IN <alias> => <alias>->(dbCloseArea())

#Command UTILITIES [<menuletter>] => DC_UTIL(<(menuletter)>)

* -- V -- *

#command VIEW => IIF(EOF(),DC_DotQOUT("'+DC_TR1MSG_4+'"),DC_EDIT(.f.,,.t.))


* -- W -- *

#command WHILE <b,...> [DO] <c,...> => DC_DOWHILE({||<b>},{||<c>})

#command WAIT [<c>] [TO <var>] => [<var> := ] DC_Wait( <c> )

#Command WHERE PUBLIC <proc> => DC_OBJPUBLIC(<(proc)>)

#Command WHERE SOURCE <cProc> => DC_ObjSourceList(<(cProc)>)

#command WHERE EXTERNAL <proc> [TO <file>]                                      ;
         => ;
         DC_OBJEXTERNAL(<(proc)>,<(file)>)' }                                   ;

#command WORK CONVERT [<file>] => DC_WORKCONVERT(<(file)>)

#command WORK RESTORE => DC_WORKREST()

#command WORK RESTORE [FROM <file>] [<a:ADDITIVE>] [<e:EXCLUSIVE>]                      ;
         [<n:NONADDITIVE>] [<q:QUIET>] [<v:VERBOSE>]                                    ;
         => ;
         DC_WORKREST(<(file)>,<.a.>.OR.!<.n.>,!<.q.>.AND.<.v.>,,<.e.>)

* -- X -- *

#Command XPP <file> [ OPTIONS <options> ] [<q:QUIET>] [<w:NOWINDOW>]    ;
         [<r:RECOMPILE>]                                                ;
         =>                          ;                                      ;
         DC_Compile( <(file)>, <(options)>, <.q.>, !<.w.>, <.r.> )

* -- Y -- *


* -- Z -- *

#Command ZAP => DC_Zap()



