/*
 ķ
   Program..: _DCAREA1.prg                                                   
   Author...: Roger Donnay                                                   
   Notice...: (c) DONNAY Software Designs 1987-2000                          
   Date.....: May 22, 2000                                                   
   Notes....: Work Area Functions                                            
                                                                             
   Functions: dc_workarray(), dc_isrlock(), dc_isflock(), dc_lockedrec(),    
              dc_hasmemo(), dc_hasmemo(), dc_dbfhandle(), dc_dbthandle(),    
              dc_isshared(), dc_readonly(), dc_locate(), dc_indexcount(),    
              dc_dbfname(), dc_dbtname(), dc_indexname(), dc_workinfo(),     
              dc_ntxhandle(), dc_childcount(), dc_dbstruct(), dc_fldtype(),  
              dc_setpass()                                                   
 Ľ
*/

#include 'set.ch'
#include 'dcfiles.ch'
#include 'dmlb.ch'
#include 'dbfdbe.ch'
#INCLUDE "dccargo.CH"
#INCLUDE "dcdialog.CH"
#INCLUDE "appevent.CH"

#define ADSDBE_INDEX_EXT       (DBE_USER+2) // RW
#define DCAREAMSG_1  'Invalid Expression in Index Key:'

MEMVAR cFilter


// ----------------- //

FUNCTION dc_workarray ( nArea )

/*
LOCAL aWork := {}, nCount, aWork2

DC_VALTYPE( @nArea,SELE() )
IF EMPTY(ALIAS(nArea))
  RETURN {}
ENDIF
FOR nCount := 1 TO 7
  AADD( aWork, DC_WORKH52( nArea, nCount ))
NEXT
FOR nCount := 1 TO 10
  IF EMPTY(DBRELATION(nCount))
    EXIT
  ENDIF
NEXT
AADD( aWork, DC_WORKH52( nArea, nCount-1 ))
FOR nCount := 9 TO 20
  AADD( aWork, DC_WORKH52( nArea, nCount ))
NEXT
AADD( aWork, 0 )
AADD( aWork, {} )
aWork2 := DC_ACONVERT(dbStruct())
AADD( aWork, aWork2[1] )
AADD( aWork, aWork2[2] )
AADD( aWork, aWork2[3] )
AADD( aWork, aWork2[4] )
RETURN aWork
*/
RETURN nil

// ----------------- //

FUNCTION dc_isflock ( nArea )
LOCAL nSaveArea := SELECT()
LOCAL lIsFlock := .f.
nArea := IIF(Valtype(nArea)='N',nArea,nSaveArea)
SELE (nArea)
IF !EMPTY(Alias())
  lIsFlock := .f. // dbInfo( DBI_ISFLOCK )
ENDIF
SELE (nSaveArea)
RETURN lIsFlock

// ----------------- //

FUNCTION dc_isrlock ( nArea )
LOCAL nSaveArea := SELECT()
LOCAL lIsRlock := .f.
nArea := IIF(Valtype(nArea)='N',nArea,nSaveArea)
SELE (nArea)
IF !EMPTY(Alias())
  lIsRlock := AScan( DbRLockList(),RecNo() ) > 0
ENDIF
SELE (nSaveArea)
RETURN lIsRlock

// ----------------- //

FUNCTION dc_lockedrec ( nArea )
RETURN DC_WORKINFO( nArea,, nWK_LOCKEDREC, 0 )

// ----------------- //

FUNCTION dc_hasmemo ( nArea )

LOCAL nSaveArea := SELECT()
LOCAL lHasMemo := .f.
nArea := IIF(Valtype(nArea)='N',nArea,nSaveArea)
SELE (nArea)
IF !EMPTY(Alias())
  lHasMemo := dbInfo( DBFDBO_DBTHANDLE ) > 0
ENDIF
SELE (nSaveArea)
RETURN IIF(Valtype(lHasMemo)='L',lHasMemo,.f.)

// ----------------- //

FUNCTION dc_dbfhandle ( nArea )
LOCAL nSaveArea := SELECT()
LOCAL nHandle := 0
nArea := IIF(Valtype(nArea)='N',nArea,nSaveArea)
SELE (nArea)
IF !EMPTY(Alias())
  nHandle := dbInfo( DBFDBO_DBFHANDLE )
ENDIF
SELE (nSaveArea)
RETURN IIF(Valtype(nHandle)='N',nHandle,0)

// ----------------- //

FUNCTION dc_dbthandle ( nArea )

LOCAL nSaveArea := SELECT()
LOCAL nHandle := 0
nArea := IIF(Valtype(nArea)='N',nArea,nSaveArea)
SELE (nArea)
IF !EMPTY(Alias())
  nHandle := dbInfo( DBFDBO_DBTHANDLE )
ENDIF
SELE (nSaveArea)
RETURN IIF(Valtype(nHandle)='N',nHandle,0)

// ----------------- //

FUNCTION dc_ntxhandle ( nArea, nOrder )

/*
LOCAL nHandle := 0
LOCAL nSaveArea := SELECT()
DC_VALTYPE( @nOrder,INDEXORD(),  @nArea,nSaveArea )
SELE (nArea)
IF !EMPTY(Alias())
  nHandle := dbOrderInfo( DBOI_FILEHANDLE,, nOrder )
ENDIF
SELE (nSaveArea)
RETURN IIF(Valtype(nHandle)='N',nHandle,0)
*/
RETURN 0

// ----------------- //

FUNCTION dc_isshared ( nArea )

LOCAL nSaveArea := SELECT()
LOCAL lIsShared := .f.
nArea := IIF(Valtype(nArea)='N',nArea,nSaveArea)
SELE (nArea)
IF !EMPTY(Alias())
  lIsShared := dbInfo( DBO_SHARED )
ELSE
  lIsShared := !SET(_SET_EXCLUSIVE)
ENDIF
SELE (nSaveArea)
RETURN IIF(Valtype(lIsShared)='L',lIsShared,.t.)

// ----------------- //

FUNCTION dc_readonly ( nArea )

LOCAL nSaveArea := SELECT()
LOCAL lReadOnly := .f.
nArea := IIF(Valtype(nArea)='N',nArea,nSaveArea)
SELE (nArea)
lReadOnly := .t.
#if XPPVER > 1900000
IF !EMPTY(Alias())
  lReadOnly := dbInfo( DBO_READONLY )
ENDIF
#endif
SELE ( nSaveArea )
RETURN IIF(Valtype(lReadOnly)='L',lReadOnly,.f.)

// ----------------- //

FUNCTION dc_locate ( nArea )
#ifdef CLIPPER53
  RETURN ''
#else
  RETURN DC_WORKINFO( nArea,, nWK_LOCATE, '' )
#endif

// ----------------- //

FUNCTION dc_indexcount ( nArea )
LOCAL i, nOldArea

IF EMPTY(ALIAS())
  RETURN 0
ENDIF
nOldArea := SELE()
IF VALTYPE(nArea)='N'
  SELE (nArea)
ENDIF
FOR i := 1 TO 99
  IF EMPTY(OrdBagName(i))
    EXIT
  ENDIF
NEXT
SELE (nOldArea)
RETURN i-1

// ----------------- //

FUNCTION dc_childcount ( nArea )
LOCAL nSaveArea := SELECT(), nChildCount := 0, i
nArea := IIF(VALTYPE(nArea)='N',nArea,SELECT())
SELE (nArea)
IF !EMPTY(Alias())
  #ifdef CLIPPER53
    nChildCount := dbInfo( DBI_CHILDCOUNT )
  #else
    FOR i := 1 TO 10
      IF !EMPTY(DBRELATION(i))
        nChildCount++
      ENDIF
    NEXT
  #endif
ENDIF
SELE (nSaveArea)
RETURN nChildCount

// ----------------- //

FUNCTION dc_dbfname ( nArea )

LOCAL nSaveArea := SELECT()
LOCAL nHandle := 0, cDbfName := '', cDbfExt
nArea := IIF(Valtype(nArea)='N',nArea,nSaveArea)
SELE (nArea)
IF !EMPTY(Alias())
  cDbfName := DC_DbCargo()[DCCARGO_DBF_NAME]
ENDIF
IF Empty(cDbfName)
  cDbfname := dbInfo( DBO_FILENAME )
ENDIF
SELE (nSaveArea)
IF EMPTY(cDbfName)
  DO CASE
    CASE ' '+ DC_SetRdd() + ' ' $ ;
     ' DBFMDX DBFNDX DBFNTX DBF DBFCDX DBFCMX FORTRESS COMIX SIXNTX DBFSIX SIXCDX DBFNSX SIXNSX '
      cDbfExt := '.DBF'
  ENDCASE
  IF !EMPTY(cDbfExt)
    cDbfName := Alias() + cDbfExt
  ELSE
    cDbfName := ''
  ENDIF
ENDIF
RETURN cDbfName

// ----------------- //

FUNCTION dc_dbtname ( nArea )

LOCAL cDbfName, cDbtExt, cDbfExt, cRdd := dbeSetDefault(DC_SetRdd())

cDbfName := DC_DbfName( nArea )
cDbfExt := Substr(cDbfName,At('.',cDbfName))
cDbtExt := DC_DbeInfo( COMPONENT_DATA, DBFDBE_MEMOFILE_EXT )
dbeSetDefault(cRdd)

RETURN StrTran(cDbfName,cDbfExt,'.'+cDbtExt)

* ------------------ *

FUNCTION dc_cdxname ( nArea )

LOCAL cDbfName, cCdxExt
cDbfName := DC_DbfName( nArea )
IF DC_SetRdd() == 'ADSDBE'
  cCdxExt := DC_DbeInfo( COMPONENT_DATA, ADSDBE_INDEX_EXT )
ELSE
  cCdxExt := 'CDX'
ENDIF
RETURN StrTran(cDbfName,'.DBF','.'+cCdxExt)

// ----------------- //

FUNCTION dc_indexname ( nArea, nOrder )

LOCAL cIndexName := '', nSaveArea := Select(), cPath

nArea := IIF(Valtype(nArea)='N',nArea,Select())
IF EMPTY(ALIAS(nArea))
  RETURN ''
ENDIF
nOrder := IIF(Valtype(nOrder)='N',nOrder,IndexOrd() )
IF Valtype( nArea ) = 'N' .AND. nArea > 0
  SELE ( nArea )
ENDIF
cIndexName := OrdBagName( nOrder )
cPath := DC_Path(DC_DbfName())
SELE ( nSaveArea )

IF !Empty(cIndexName) .AND. !Empty(cPath) .AND. Empty(DC_Path(cIndexName))
  cIndexName := cPath + cIndexName
ENDIF

RETURN cIndexName

* ----------------- *

FUNCTION dc_dbstruct( nMode )

LOCAL i, aStru := dbStruct()

nMode := IIF( Valtype(nMode) = 'N', nMode, 0 )

IF nMode == 0
  RETURN DC_ACONVERT( aStru )
ELSEIF nMode == 1
  FOR i := 1 TO Len(aStru)
    ASize(aStru[i],7)
    aStru[i,7] := &(Fieldname(i))
  NEXT
ENDIF
RETURN aStru

* ----------------- *

FUNCTION dc_workinfo ( nArea, nSubArea, nPointer, xValue )

/*
DC_VALTYPE( @nArea,SELE() )
IF nArea = 0
  nArea := SELE()
ENDIF
IF EMPTY(ALIAS(nArea))
  RETURN xValue
ENDIF
IF VALTYPE(nSubArea)='N'
  RETURN DC_WORKH52( nArea, nSubArea, nPointer )
ENDIF
RETURN DC_WORKH52( nArea, nPointer )
*/
RETURN nil

* ----------------- *

FUNCTION dc_fldtype ( cField )

LOCAL cType := TYPE(cField), cRdd := DC_SETRDD(), aStructure, i
IF cRdd = 'FLEXFILE' .AND. cType = 'C'
  cField := UPPER(ALLTRIM(cField))
  aStructure := dbStruct()
  FOR i := 1 TO LEN(aStructure)
    IF aStructure[i,1] == cField
      RETURN aStructure[i,2]
    ENDIF
  NEXT
ENDIF
RETURN cType

* ----------------- *

FUNCTION DC_SetPass ( cPassWord )

IF DC_SetRdd() == 'ADSDBE' .AND. IsFunction('AX_SetPass')
  &('AX_SetPass("' + cPassWord + '")')
  RETURN .t.
ENDIF
RETURN .f.

* -------------- *

FUNCTION DC_DataSave

LOCAL aData := {0,{}}, i, j, nSaveOrder, nRelation, cDBRelation, cDBAlias

aData[1] := Select()
FOR i := 1 TO 254
  SELE (i)
  IF !Empty(Alias())
    AADD(aData[2],{ i, ;                      //  1 Workarea
                    Alias(), ;                //  2 Alias
                    DbInfo( DBO_FILENAME ),;  //  3 File name
                    DC_SetRdd(),;             //  4 Rdd
                    RecNo(),;                 //  5 Record pointer
                    IndexOrd(),;              //  6 Index order
                    DC_IsShared(),;           //  7 Shared
                    DC_ReadOnly(),;           //  8 Read Only
                    DC_IsCombined(),;         //  9 Combined Index
                    DC_IndexName(),;          // 10 Index name
                    {}, ;                     // 11 Indexes
                    {}  ;                     // 12 Relations
                   } )
    IF !DC_IsCombined()
      nSaveOrder := IndexOrd()
      FOR j := 1 TO 99
        OrdSetFocus(j)
        IF !Empty(DC_TagName()) .AND. IndexOrd()=j
          AADD( aData[2,LEN(aData[2]),11], DC_IndexName() )
        ELSE
          EXIT
        ENDIF
      NEXT
      OrdSetFocus(nSaveOrder)
    ENDIF
    FOR nRelation := 1 TO 10
      IF !EMPTY( DBRELATION( nRelation ) )
        cDBrelation := DBRELATION( nRelation )
        cDBalias := ALIAS( DBRSELECT( nRelation ) )
        AADD( aData[2,LEN(aData[2]),12], { cDBrelation, cDBAlias } )
      ENDIF
    NEXT nRelation
  ENDIF
NEXT
SELE (aData[1])
RETURN aData

* -------------- *

FUNCTION DC_DataRest ( aData )

LOCAL i, j, cDBAlias, cDBRelation

IF Valtype(aData) # 'A'
  RETURN .f.
ENDIF
FOR i := 1 TO LEN(aData[2])
  SELE (aData[2,i,1])
  DC_UseArea( , aData[2,i,4], aData[2,i,3], aData[2,i,2], aData[2,i,7], ;
                aData[2,i,8], ;
               .t., .t., .t., .t. )
  IF !Empty(aData[2,i,10])
    OrdListAdd(aData[2,i,10])
  ENDIF

  IF !Empty(aData[2,i,11])
    FOR j := 1 TO LEN(aData[2,i,11])
      dbSetIndex(aData[2,i,11,j])
    NEXT
  ENDIF
  OrdSetFocus(aData[2,i,6])
  dbGoTo(aData[2,i,5])
NEXT
FOR i := 1 TO LEN(aData[2])
  SELE (aData[2,i,1])
  IF !Empty(aData[2,i,12])
    FOR j := 1 TO LEN(aData[2,i,12])
      cDBrelation := aData[2,i,12,j,1]
      cDBalias := aData[2,i,12,j,2]
      dbSetRelation( cDBAlias, &('{||'+cDBRelation+'}'), cDBRelation )
    NEXT
  ENDIF
NEXT
SELE (aData[1])
RETURN .t.

* --------------- *

FUNCTION DC_Lookup ( cAlias, xIndex, cExpr, xLookup, xDefault )

LOCAL nSaveRec, xValue, nSaveArea := Select(), nSaveOrd

IF Empty(cAlias) .OR. Empty(cExpr) .OR. Empty(xLookup) .OR. Empty(xIndex)
  RETURN xDefault
ENDIF
IF !DC_DbSel(cAlias)
  RETURN xDefault
ENDIF
nSaveRec := RecNo()
nSaveOrd := IndexOrd()
OrdSetFocus(xIndex)
IF IndexOrd() > 0
  SEEK xLookup
  xValue := &cExpr
  IF Valtype(xValue)='B'
    xValue := Eval(xValue)
  ENDIF
  OrdSetFocus(nSaveOrd)
  GO nSaveRec
  SELE (nSaveArea)
ELSE
  xValue := xDefault
ENDIF
RETURN xValue

* --------------- *

FUNCTION DC_IsField ( cFieldName, nField )

LOCAL aArea := ARRAY(FCOUNT())
cFieldName := IIF(VALTYPE(cFieldName)='C',UPPER(ALLTRIM(cFieldName)),'')
AFIELDS( aArea )
IF SUBSTR(cFieldName,1,1)='('
  cFieldName := SUBSTR(cFieldName,2)
  cFieldName := SUBSTR(cFieldName,1,LEN(cFieldName)-1)
ENDIF
nField := ASCAN( aArea, {|x|x==cFieldName} )
RETURN nField # 0

* ----------------- *

FUNCTION DC_IsUnique ( nOrder )

LOCAL nSaveOrd, lUnique := .f.

IF Empty(Alias())
   RETURN .f.
ENDIF
IF !Empty(nOrder)
  nSaveOrd := IndexOrd()
  OrdSetFocus(nOrder)
ENDIF
IF IndexOrd() > 0
  lUnique := OrdIsUnique()
ENDIF
IF !Empty(nOrder)
  OrdSetFocus(nSaveOrd)
ENDIF

RETURN lUnique

* ----------------- *

FUNCTION DC_IsDescend( nOrder )

LOCAL nSaveOrd, lDescend := .f.

IF Empty(Alias())
   RETURN .f.
ENDIF
IF !Empty(nOrder)
  nSaveOrd := IndexOrd()
  OrdSetFocus(nOrder)
ENDIF
IF IndexOrd() > 0
  lDescend := OrdIsDescend()
ENDIF
IF !Empty(nOrder)
  OrdSetFocus(nSaveOrd)
ENDIF

RETURN lDescend

* ----------------- *

FUNCTION  DC_IsCdx()

RETURN '.CDX' $ DC_INDEXNAME()

* ----------------- *

FUNCTION DC_IsCombined( cRdd )

cRdd := ALLTRIM(UPPER(IIF(Valtype(cRdd)='C',cRdd, DC_SuperRdd())))

RETURN DC_IsCdx() .OR. ' ' + cRdd + ' ' $ ;
 ' FOXCDX DBFCDXAX DBFCDX DBFMDX FORTRESS COMIX DBFCMX DBFMTX ' ;
 .OR. ( cRdd = 'ADSDBE' .AND. DC_DbeInfo( COMPONENT_DATA, DBE_USER+3 ) $ {2,3} )

* ----------------- *

FUNCTION DC_SetOrder ( nOrder )

IF !EMPTY(OrdBagName( nOrder ))
  RETURN OrdSetFocus( nOrder )
ENDIF
RETURN nil

* ---------------- *

FUNCTION dc_resetindex

LOCAL cIndexName := DC_INDEXNAME()
IF !EMPTY(cIndexName)
  IF ' '+DC_SUPERRDD()+' '$' DBFNTX SIXNTX DBFNTXAX DBFNDX '
    OrdListClear()
  ENDIF
ENDIF
RETURN nil

* --------------- *

FUNCTION DC_OrdCreate ( cBag, cTag, cKey, bKey, lUnique, lAdditive )

LOCAL cCdxExt, cDbfExt, cDbfName

IF dbeSetDefault() # 'ADSDBE'
  IF !DC_ReUseExclusive()
    RETURN nil
  ENDIF
ENDIF

IF TYPE(cKey)$"UE"
  DC_MsgBox(,,{DCAREAMSG_1,cKey},,.t.)
  DC_OdActive(.f.)
  RETURN nil
ENDIF

IF Empty(cBag)
  cCdxExt  := DC_CdxExt()
  cDbfExt  := DC_DbfExt()
  cDbfName := DC_TableName()
  cBag     := Strtran( cDbfName, cDbfExt, cCdxExt )
ENDIF

RETURN ordCreate( cBag, cTag, cKey, bKey, lUnique, lAdditive )

* ------------ *

FUNCTION DC_KeyIncr( xKeyVal )

LOCAL i, s, lBool, nKeyLen, xNewVal

IF Valtype( xKeyVal )= 'C'
  lBool := .T.
  nKeyLen := Len( s := xKeyVal )
  FOR i = 1 TO nKeyLen
    IF !IsDigit( SubStr( s, i, 1 ) )
      lBool := .F.
      EXIT
    ENDIF
  NEXT
  IF lBool
    nKeyLen := Len( xKeyVal )
    xNewVal := Val( xKeyVal ) + 1
    IF Len( Rtrim( xKeyVal ) ) #  nKeyLen
      xKeyVal := PadR( Ltrim( Str( xNewVal ) ), nKeyLen )
    ELSEIF ' ' $ xKeyVal
      xKeyVal := Str( xNewVal, nKeyLen )
    ELSE
      xKeyVal := _DCPadZero( Str(xNewVal), nKeyLen )
    ENDIF
  ELSE
    xKeyVal := Left( xKeyVal, Len( xKeyVal ) - 1 ) + ;
    Chr( Asc( Right( xKeyVal, 1 ) ) + 1 )
  ENDIF

ELSEIF ValType( xKeyVal ) $ "ND"
  xKeyVal++
ENDIF
RETURN xKeyVal

* ------------ *

STATIC FUNCTION _DCPadZero( xValue, nLen )
IF Valtype(nLen) = 'N'
ELSEIF ValType(xValue) == "C"
  nLen := Len(xValue)
ELSE
  nLen := 6
ENDIF
IF ValType(xValue) == "C"
  RETURN PadL(AllTrim(xValue),nLen,"0")
ELSEIF ValType(xValue) == "N"
  RETURN PadL(AllTrim(Str(xValue)),nLen,"0")
ENDIF
RETURN Replicate("0",nLen)

* ------------- *

FUNCTION DC_KeyOrder( cFieldName, cPreField )

LOCAL i, cKey
cPreField := UPPER(IIF(Valtype(cPreField)='C',cPreField,''))

IF EMPTY(Alias())
  RETURN 0
ENDIF
IF !Empty(cPreField)
  cKey := DC_DefTran(cKey,cPreField,'_XXYYZZ_',.f.)
ENDIF
FOR i := 1 TO 99
  IF EMPTY(IndexKey(i))
    i := 0
    EXIT
  ELSEIF !Empty(OrdFor())
    // nothing
  ELSE
    cKey := Upper(IndexKey(i))
    /* -- Strip out unwanted leading function references -- */
    DO WHILE .T.
      IF '->' $ cKey
        cKey := Substr(cKey,AT('->',cKey)+2,250)
      ELSEIF ! '(' $ cKey
        EXIT
      ELSEIF cKey = "UPPER("
        cKey := Substr(cKey,7,250)
      ELSEIF cKey = "LOWER("
        cKey := Substr(cKey,7,250)
      ELSEIF cKey = "LEFT("
        cKey := Substr(cKey,6,250)
      ELSEIF cKey = "TRIM("
        cKey := Substr(cKey,6,250)
      ELSEIF cKey = "RTRIM("
        cKey := Substr(cKey,7,250)
      ELSEIF cKey = "SUBSTR("
        cKey := Substr(cKey,8,250)
      ELSEIF cKey = "DESCEND("
        cKey := Substr(cKey,9,250)
      ELSEIF cKey = "STR("
        cKey := Substr(cKey,5,250)
      ELSEIF cKey = "ALLTRIM("
        cKey := Substr(cKey,9,250)
      ELSEIF cKey = "DTOS("
        cKey := Substr(cKey,6,250)
      ELSEIF cKey = "CTOD("
        cKey := Substr(cKey,6,250)
      ELSEIF cKey = "DTOC("
        cKey := Substr(cKey,6,250)
      ELSEIF cKey = "PADR("
        cKey := Substr(cKey,6,250)
      ELSEIF cKey = "PAD("
        cKey := Substr(cKey,5,250)
      ELSEIF cKey = "UNTRIM("
        cKey := Substr(cKey,6,250)
      ELSEIF cKey = '_XXYYZZ_'
        cKey := Substr(cKey,9,250)
      ELSEIF SubStr(cKey,1,1)$['"()$%#,=+-.<>/{}@!^&*|\/:;]
        cKey := SubStr(cKey,2,250)
      ELSE
        EXIT
      ENDIF
    ENDDO
    IF cKey = Upper(cFieldName)
      EXIT
    ENDIF
  ENDIF
NEXT
IF i > 99
  i := 0
ENDIF
RETURN i

* ------------------- *

FUNCTION DC_Relation( nRel )

nRel := IIF(Valtype(nRel)='N',nRel,0)

IF Empty(Alias()) .OR. nRel = 0
  RETURN ''
ENDIF
RETURN dbRelation(nRel)

* ------------------- *

STATIC PROC _dcarea2err

BREAK
RETURN

* ------------------- *

FUNCTION dc_relarray ( aArray, lFillRel, lAllSubs )

LOCAL  nWorkSave, nRelSelect, nRelation, i

nWorkSave := Select()
lFillRel  := IIF(Valtype(lFillRel)='L',lFillRel,.f.)
lAllSubs  := IIF(Valtype(lAllSubs)='L',lAllSubs,.f.)
IF !lFillRel
  aArray := { {ALIAS(),Select()} }
ENDIF
FOR nRelation := 1 TO 10
  nRelSelect := DBRSELECT(nRelation)
  IF nRelSelect>0
    IF DC_DBSEL(ALIAS(nRelSelect))
      AADD( aArray, { ALIAS(), Select()} )
      IF lAllSubs
        DC_RelArray( aArray,.t.,.t. )
      ENDIF
    ENDIF
    SELE (nWorkSave)
  ENDIF
NEXT nRelCount
RETURN aArray

/* ------------------- */

FUNCTION dc_relasave ()

LOCAL aRelation := {}, nRelation
FOR nRelation := 1 TO 10
  IF !EMPTY( DBRELATION( nRelation ) )
    AADD( aRelation, { dbRelation(nRelation), Alias(dbrSelect(nRelation)) } )
  ENDIF
NEXT
RETURN aRelation

/* --------------------- */

FUNCTION dc_relarest ( aRelation )

LOCAL i, cRdd := DC_SuperRdd(), cRelExpr, cRelAlias

FOR i := 1 TO LEN(aRelation)
  cRelAlias := aRelation[i,2]
  cRelExpr  := aRelation[i,1]
  dbSetRelation( cRelAlias, &('{||'+cRelExpr+'}'), cRelExpr )
NEXT
RETURN nil


/* --------------------- */

FUNCTION dc_setfilter ( cSetFilter, lOptimize )

LOCAL cRdd := DC_SetRdd(), bSetFilter
lOptimize = IIF(Valtype(lOptimize)='L',lOptimize,.f.)
IF !Empty(Alias())
  IF ( Empty(cSetFilter) )
    dbClearFilter()
  ELSE
    bSetFilter := &('{||'+cSetFilter+'}')
    IF cRdd == 'ADSDBE'
      dbSetFilter( bSetFilter )
    ELSE
      dbSetFilter( bSetFilter, cSetFilter )
    ENDIF
  ENDIF
ENDIF
RETURN nil

* ------------------ *

FUNCTION DC_DbCreate( cFileName, aField, aType, aLength, aDecimal, cDbe )

LOCAL i, aStructure := {}

FOR i := 1 TO Len(aField)
  AAdd(aStructure, { aField[i], aType[i], aLength[i], aDecimal[i] } )
NEXT

RETURN dbCreate( cFileName, aStructure, cDbe )

* ------------------- *

FUNCTION DC_SeekLast( uVariable )

LOCAL cIndexKey, nLen, lRetVal := .f., cRdd

cRdd := DC_SetRdd()
IF .f. // cRdd == 'ADSDBE' .AND. IsFunction('AX_SeekLast')
  RETURN &('AX_SeekLast("' + DC_XtoC(uVariable) + '")')
ENDIF

BEGIN SEQUENCE

cIndexKey := Indexkey( 0 )
IF empty( cIndexKey )                // no index active
  BREAK
ENDIF

DO CASE

   CASE Valtype( uVariable ) == 'C'

      // increase last Chr() by 1 for SOFTSEEK
      nLen := len( uVariable )
      // SOFTSEEK ON !
      dbseek( left( uVariable, nLen - 1 ) + chr( asc( right( uVariable, 1 ) ) + 1 ), .T. )

      // skip back 1
      dbskip( - 1 )

      // determine value of index key
      IF ( uVariable == left( &( cIndexKey ), nLen ) )
         // match found!
         lRetVal := .t.
         break
      ENDIF

   CASE Valtype( uVariable ) == 'D'

      // increase date by 1 for SOFTSEEK
      dbseek( uVariable + 1, .T. )

      // skip back 1
      dbskip( - 1 )

      // determine value of index key
      IF uVariable == &( cIndexKey )
         // match found!
         lRetVal := .t.
         break
      ENDIF

   CASE Valtype( uVariable ) == 'N'

      // increase numeric by 1 for SOFTSEEK
      dbseek( uVariable + 1, .T. )

      // skip back 1
      dbskip( - 1 )

      // determine value of index key
      IF uVariable == &( cIndexKey )
         // match found!
         lRetVal := .t.
         break
      ENDIF

   OTHERWISE

      BREAK

ENDCASE

// if Eof() was .T.
dbskip( 1 )

END SEQUENCE

RETURN lRetVal

* -----------------------------

FUNCTION dc_dbfext ( cRdd, cFileName )
LOCAL cExt := _dcext( cRdd, cFileName, 3 )
IF EMPTY(cExt)
  RETURN ''
ENDIF
RETURN cExt

// ----------------- //

FUNC dc_dbtext ( cRdd, cFileName )
LOCAL cExt := _dcext( cRdd, cFileName, 6 ), cDbtName
IF EMPTY(cExt)
  IF Empty(cRdd)
    cRdd := DC_SetRdd()
    cDbtName := DC_DbtName()
    IF !Empty(cDbtName)
      RETURN Substr(cDbtName,AT('.',cDbtName))
    ELSEIF ' ' + cRdd + ' ' $ ' COMIX DBFCDX DBFCDXAX FORTRESS DBFCMX SIXCDX '
      RETURN '.FPT'
    ELSEIF ' ' + cRdd + ' ' $ ' DBFNTX DBFNDX DBFNTXAX DBFMDX SIXNTX DBF '
      RETURN '.DBT'
    ELSEIF cRdd = 'ADSDBE'
      cExt := DC_DbeInfo( COMPONENT_DATA, DBE_USER + 1 )
    ENDIF
  ENDIF
  RETURN ''
ENDIF
RETURN cExt

// ----------------- //

FUNCTION dc_ntxext ( cRdd, cFileName )

LOCAL cExt, cSaveRdd := dbeSetDefault( cRdd )
cExt := IndexExt()
dbeSetDefault( cSaveRdd )

RETURN cExt

// ----------------- //

FUNCTION dc_cdxext ( cRdd, cFileName )
LOCAL cExt := _dcext( cRdd, cFileName, 5 )
IF EMPTY(cExt)
  RETURN DC_NTXEXT( cRdd, cFileName )
ENDIF
RETURN cExt

// ----------------- //

STATIC FUNCTION _dcext ( cRdd, cFileName, nElement )

LOCAL i
cFileName := IIF(Valtype(cFileName)='C',cFileName,'')
IF '.\'$cFileName
  cFileName := SUBSTR(cFileName,AT('.\',cFileName)+2)
ENDIF
i := AT('.',cFileName)
IF i > 0
  FOR i := LEN(cFileName) TO 1 STEP -1
    IF SUBSTR(cFileName,i,1)=='.'
      cFileName := SUBSTR(cFileName,i)
      RETURN IIF(LEN(cFileName)>4,'',cFileName)
    ENDIF
  NEXT
ENDIF
RETURN DC_RDDINFO(cRdd)[nElement]

* -----------------

FUNCTION DC_DbeInfo( nParam1, nParam2, nParam3 )

LOCAL cRdd := dbeSetDefault(), xValue

dbeSetDefault(DC_SetRdd())
xValue := DbeInfo( nParam1, nParam2, nParam3 )
dbeSetDefault(cRdd)

RETURN xValue

* -----------------

FUNCTION DC_RecSize()

LOCAL i, nSize := 0, aStru := dbStruct()

FOR i := 1 TO Len(aStru)
  nSize += aStru[i,3]
NEXT

RETURN nSize + 1

* ------------------

FUNCTION DC_DbExport( cFile, aFields, bFor, bWhile, nNext, nRec, ;
                      lRest, cDbe, cDelim, nEvery, cTitle, cPrompt, ;
                      lExit, lProgress )

LOCAL GetList[0], GetOptions, oDlg, lWorking := .f., oStatic, ;
      nMaxCount, oProgress, bEval, oStartButton, oExitButton

DEFAULT cTitle := ' Copy Records', ;
        cPrompt := ' Records Copied', ;
        lExit := .f., ;
        lProgress := .t.

IF Empty(Alias())
  RETURN .f.
ENDIF

IF Empty(cDbe) .AND. DC_SetRdd() == 'ADSDBE'
  cDbe := DC_AdsSessionDict('Free')
ENDIF

nMaxCount := DC_KeyCount()

DEFAULT nEvery := Int(nMaxCount/100)

@ 0,0 DCSAY cTitle SAYSIZE 0

@ 1,0 DCSAY '' SAYSIZE 50,1 COLOR GRA_CLR_BLUE, GRA_CLR_WHITE ;
      FONT '10.Courier New Bold' OBJECT oStatic

@ 2,0 DCPROGRESS oProgress SIZE 50, 1 ;
      TYPE XBPSTATIC_TYPE_TEXT ;
      COLOR GRA_CLR_YELLOW, GRA_CLR_WHITE ;
      PERCENT ;
      PERCENTCOLOR GRA_CLR_RED ;
      RADIUS 20 ;
      OUTLINE ;
      DYNAMIC

@ 3.5,0 DCPUSHBUTTON CAPTION 'Start' SIZE 9,1.2 ;
       ACTION {||DC_DbGoTop(), ;
                 lWorking := .t., ;
                 DC_GetRefresh(GetList), ;
                 Eval(bEval)} ;
       WHEN {||!lWorking} OBJECT oStartButton

@ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'Cancel' SIZE 9,1.2 ;
       ACTION {||lWorking := .f.,DC_GetRefresh(GetList)} ;
       WHEN {||lWorking}

@ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'Exit' ;
      SIZE 9,1.2 ACTION {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)} ;
      WHEN {||!lWorking} OBJECT oExitButton

bEval := {||_export(cFile,aFields,bFor,bWhile,nRec,nNext,lRest,cDbe, ;
                    cDelim,cPrompt,@lWorking,nMaxCount,oStatic,;
                    oProgress,nEvery), ;
                    lWorking := .f., ;
                    DC_GetRefresh(GetList), ;
                    IIF(lProgress,SetAppFocus(oExitButton),nil), ;
                    IIF(lExit .AND. lProgress,PostAppEvent(xbeP_Activate,,,oExitButton),nil)}

DCGETOPTIONS NORESIZE HIDE

IF lProgress
  DCREAD GUI FIT ;
   TITLE cTitle ;
   OPTIONS GetOptions ;
   EVAL {|o|PostAppEvent(xbeP_Activate,,,oStartButton), ;
            DC_CenterObject(o,SetAppWindow()),;
            o:show()}
ELSE
   DC_DbGoTop()
   Eval(bEval)
ENDIF

RETURN nil

* -------------

STATIC FUNCTION _Export(cFile,aFields,bFor,bWhile,nRec,nNext,lRest,cDbe,cDelim, ;
                        cPrompt,lWorking,nMaxCount,oStatic,oProgress,nEvery)

LOCAL bProgress, nForCount := 0, nCount := 0

IF Valtype(oProgress) == 'O'
  bProgress := {||Progress(oProgress,bWhile,bFor,cPrompt,@lWorking, ;
                         @nCount,@nForCount,nMaxCount,oStatic,nEvery)}
ENDIF

dbExport( cFile, aFields, bFor, bProgress, nNext, nRec, lRest, cDbe, cDelim )                                                   ;

IF lWorking .AND. Valtype(oProgress) == 'O'
  DC_GetProgress(oProgress,100,100)
ENDIF

RETURN nil

* -------------

STATIC FUNCTION Progress( oProgress, bWhile, bFor, cPrompt, lWorking, ;
                          nCount, nForCount, nMaxCount, oStatic, nEvery )

LOCAL lUpdate := .f., nEvent := -1

IF !Eof()
  nCount++
ENDIF

IF Valtype(bWhile) == 'B'
  IF !Eval(bWhile)
    lWorking := .f.
    RETURN lWorking
  ENDIF
ENDIF

IF !Eof()
  IF Valtype(bFor) == 'B'
    IF Eval(bFor)
      nForCount++
     lUpdate := .t.
    ENDIF
  ELSE
    nForCount++
    lUpdate := .t.
  ENDIF
ENDIF

IF nCount % nEvery == 0
  DC_GetProgress(oProgress,nCount,nMaxCount)
  DC_CompleteEvents()
ENDIF

IF lUpdate
  oStatic:setCaption(Alltrim(Str(nForCount)) + ' ' + cPrompt)
ENDIF

RETURN lWorking

* ------------------

FUNCTION DC_DbImport( cFile, aFields, bFor, bWhile, nNext, nRec, ;
                      lRest, cDbe, cDelim, nEvery, cTitle, cPrompt, ;
                      lExit, lProgress )

LOCAL GetList[0], GetOptions, oDlg, lWorking := .f., oStatic, ;
      nMaxCount, oProgress, bEval, oStartButton, oExitButton

DEFAULT cTitle := ' Append Records', ;
        cPrompt := ' Records Appended', ;
        lExit := .f., ;
        lProgress := .t.

IF Empty(Alias())
  RETURN .f.
ENDIF

IF Empty(cDbe) .AND. DC_SetRdd() == 'ADSDBE'
  cDbe := DC_AdsSessionDict('Free')
ENDIF

nMaxCount := DC_KeyCount()

DEFAULT nEvery := Int(nMaxCount/100)

@ 0,0 DCSAY cTitle SAYSIZE 0

@ 1,0 DCSAY '' SAYSIZE 50,1 COLOR GRA_CLR_BLUE, GRA_CLR_WHITE ;
      FONT '10.Courier New Bold' OBJECT oStatic

@ 2,0 DCPROGRESS oProgress SIZE 50, 1 ;
      TYPE XBPSTATIC_TYPE_TEXT ;
      COLOR GRA_CLR_YELLOW, GRA_CLR_WHITE ;
      PERCENT ;
      PERCENTCOLOR GRA_CLR_RED ;
      RADIUS 20 ;
      OUTLINE ;
      DYNAMIC

@ 3.5,0 DCPUSHBUTTON CAPTION 'Start' SIZE 9,1.2 ;
       ACTION {||DC_DbGoTop(), ;
                 lWorking := .t., ;
                 DC_GetRefresh(GetList), ;
                 Eval(bEval)} ;
       WHEN {||!lWorking} OBJECT oStartButton

@ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'Cancel' SIZE 9,1.2 ;
       ACTION {||lWorking := .f.,DC_GetRefresh(GetList)} ;
       WHEN {||lWorking}

@ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'Exit' ;
      SIZE 9,1.2 ACTION {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)} ;
      WHEN {||!lWorking} OBJECT oExitButton

bEval := {||_Import(cFile,aFields,bFor,bWhile,nRec,nNext,lRest,cDbe, ;
                    cDelim,cPrompt,@lWorking,nMaxCount,oStatic,;
                    oProgress,nEvery), ;
                    lWorking := .f., ;
                    DC_GetRefresh(GetList), ;
                    IIF(lProgress,SetAppFocus(oExitButton),nil), ;
                    IIF(lProgress .AND. lExit,PostAppEvent(xbeP_Activate,,,oExitButton),nil)}

DCGETOPTIONS NORESIZE HIDE

IF lProgress
  DCREAD GUI FIT ;
   TITLE cTitle ;
   OPTIONS GetOptions ;
   EVAL {|o|PostAppEvent(xbeP_Activate,,,oStartButton), ;
            DC_CenterObject(o,SetAppWindow()),;
            o:show()}
ELSE
  DC_DbGoTop()
  Eval(bEval)
ENDIF

RETURN nil

* -------------

STATIC FUNCTION _Import(cFile,aFields,bFor,bWhile,nRec,nNext,lRest,cDbe,cDelim, ;
                        cPrompt,lWorking,nMaxCount,oStatic,oProgress,nEvery)

LOCAL bProgress, nForCount := 0, nCount := 0

IF Valtype(oProgress) == 'O'

  bProgress := {||Progress(oProgress,bWhile,bFor,cPrompt,@lWorking, ;
                         @nCount,@nForCount,RecCount(),oStatic,nEvery)}

ENDIF

dbImport( cFile, aFields, bFor, bProgress, nNext, nRec, lRest, cDbe, cDelim )                                                   ;

IF lWorking .AND. Valtype(oProgress) == 'O'
  DC_GetProgress(oProgress,100,100)
ENDIF

RETURN nil


